datablock explosionData(ar15Explosion : gunExplosion)
{
	soundProfile = "";
	particleEmitter = "";
	subExplosion[0] = sWepsDustSmallExplosion;
};
datablock ProjectileData(ar15Projectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 25;
	explosion 				= ar15Explosion;
	directDamageType    	= $DamageType::AR15;
	radiusDamageType    	= $DamageType::AR15;
	particleEmitter     	= sWepBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	sProjectile = 1;
	sDamageFalloff = 1;
	sDamageFalloffRatio = 0.25;
};
datablock AudioProfile(ar15FireLoopEndSound)
{
	filename    = "./sound/ar15_fireLoopEnd.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(ar15FireLoopSound : ar15FireLoopEndSound)
{
	filename    = "./sound/ar15_fireLoop.wav";
	description = AudioDefaultLooping3D;
};
datablock AudioProfile(ar15DryFireSound : ar15FireLoopEndSound)
{
	filename    = "./sound/ar15_dryfire.wav";
	description = AudioDefault3d;
};
datablock DebrisData(shell556Debris)
{
	shapeFile = "./model/shell_556.dts";
	lifetime = 6.0;
	lifetimeVariance = 1.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock DebrisData(ar15ClipDebris)
{
	shapeFile = "./model/mag_ar15_v2.dts";
	lifetime = 8.0;
	lifetimeVariance = 1.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock ExplosionData(ar15ClipExplosion)
{
	debris 					= ar15ClipDebris;
	debrisNum 				= 1;
	debrisNumVariance 		= 0;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 1;
	debrisVelocityVariance 	= 0;
};
datablock ProjectileData(ar15ClipProjectile)
{
	explosion = ar15ClipExplosion;
};
if($Pref::Swol_CreateFakeIcons)
{
	datablock ItemData(ar15Icon)
	{
		uiName = "Assault Rifle";
		iconName = "./model/icon/icon_ar15_v2";
	};
}
datablock ItemData(ar15Item)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./model/ar15_v2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Assault Rifle";
	iconName = "./model/icon/icon_ar15_v2";
	fakeIcon = ar15Icon;
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1";
	ammo = 1;
	canPutInSuitcase = 0;
	isLargeWeapon = 1;
	backImage = ar15BackImage;

	image = ar15Image;
	canDrop = true;
	
	sAmmoType = "556";
	sAmmo = 20;
	sHeat = 15;
};
datablock ShapeBaseImageData(ar15BackImage)
{
	shapeFile = "./model/ar15_v2.dts";
	emap = true;
	mountPoint = $backslot;
	offset = "0.4 -0.32 -0.1";
	rotation = eulerToMatrix("-65 0 90");
	
	item = ar15Item;
	eyeOffset = "0 0 -999";
	
	doColorShift = true;
	colorShiftColor = ar15Item.colorShiftColor;
};
datablock ShapeBaseImageData(ar15Image)
{
	className = "WeaponImage";
	shapeFile = "./model/ar15_v2.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0.00981 0.01098";
	item = ar15Item;
	ammo = " ";
	projectile = ar15Projectile;
	projectileSpread = 0.001;
	projectileHeatSpread = 0.004;
	projectileSpeed = 180;
	projectileType = Projectile;
	
	casing = shell556Debris;
	shellExitDir        = "1.14 -0.7 0.2";
	shellExitDir        = "1.2 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = true;
	colorShiftColor = ar15Item.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Idle";
	
	stateName[1]					= "Idle";
	stateTransitionOnNotLoaded[1]	= "UnloadA";
	stateTransitionOnTriggerDown[1]	= "Trigger";
	
	stateName[2]					= "Trigger";
	stateScript[2]					= "onTrigger";
	stateTimeoutValue[2]			= 0.02;
	stateSound[2]					= mac10TrigSound;
	stateSequence[2]				= "trig";
	stateTransitionOnTimeout[2]		= "FireCheckA";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Fire";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Fire";
	stateScript[5]					= "onFire";
	stateEmitter[5]					= gunFlashEmitter;
	stateEmitterTime[5]				= 0.09;
	stateFire[5]					= true;
	stateEjectShell[5]				= true;
	stateSequence[5]				= "fire";
	stateEmitterNode[5]				= "muzzlePoint";
	stateTransitionOnTimeout[5]     = "Check";
	stateTimeoutValue[5]            = 0.07;
	
	stateName[6]					= "Check";
	stateTransitionOnTriggerDown[6] = "FireCheckA";
	stateTransitionOnTimeout[6]		= "Release";
	
	stateName[7]					= "Release";
	stateScript[7]					= "onRelease";
	stateSequence[7]				= "untrig";
	stateTimeoutValue[7]			= 0.05;
	stateTransitionOnTimeout[7]		= "Wait";
	
	stateName[8]					= "Wait";
	stateTimeoutValue[8]			= 0.05;
	stateTransitionOnTimeout[8]		= "Idle";
	
	stateName[9]					= "UnloadA";
	stateSequence[9]				= "unload";
	stateTimeoutValue[9]			= 0.01;
	stateScript[9]					= "onUnload";
	stateTransitionOnTimeout[9]		= "UnloadB";
	
	stateName[10]					= "UnloadB";
	stateTimeoutValue[10]			= 1.3;
	stateTransitionOnTimeout[10]	= "ReloadA";
	
	stateName[11]					= "ReloadA";
	stateSequence[11]				= "reload";
	stateTimeoutValue[11]			= 0.01;
	stateScript[11]					= "onReloadA";
	stateTransitionOnTimeout[11]	= "ReloadB";
	
	stateName[12]					= "ReloadB";
	stateTimeoutValue[12]			= 0.7;
	stateTransitionOnTimeout[12]	= "ReloadC";
	
	stateName[13]					= "ReloadC";
	stateScript[13]					= "onReloadB";
	stateTimeoutValue[13]			= 0.2;
	stateSequence[13]				= "fire";
	stateTransitionOnTimeout[13]	= "Idle";
	
	stateName[14]					= "DryFire";
	stateScript[14]					= "onDryFire";
	stateTransitionOnTriggerUp[14]	= "Release";
};
function ar15Image::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function ar15Image::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	%pl.playThread(2,plant);
	
	sWeps_loopingAudioStart(%db,%pl,%slot,ar15FireLoopSound);
	sWeps_fire(%db,%pl,%slot);
	
	%val = sAmmo_dec(%db,%pl,%slot);
	if(!sAmmo_check(%db,%pl,%slot))
		serverPlay3D(mac10LastRoundSound,%pl.getPosition());
		
	if(getSimTime()-%pl.lastShellSound > 400 || getRandom(0,1) == 0)
	{
		%pl.lastShellSound = getSimTime();
		schedule(getRandom(200,300),0,serverPlay3D,small_bulletDrop @ getRandom(1,5) @ Sound,%pl.getPosition());
	}
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
}
function ar15Image::onUnload(%db,%pl,%slot)
{
	sWeps_display(%pl,0);
	%up = %pl.getUpVectorHack();
	%forward = %pl.getEyeVectorHack();

	%p = new projectile()
	{
		datablock = ar15ClipProjectile;
		initialPosition = vectorAdd(%pl.getMuzzlePoint(%slot),vectorRelativeShift(%forward,%up,"-1.6 0 -1.2"));
	};
	%p.explode();
	%pl.playThread(2,shiftTo);
	serverPlay3D(ak47UnloadSound,%pl.getPosition());
}
function ar15Image::onReloadA(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	serverPlay3D(ak47LoadSound,%pl.getPosition());
	sAmmo_reload(%db,%pl,%slot);
	%pl.sWeps_fireDelay[%db] = getSimTime()+800;
}
function ar15Image::onReloadB(%db,%pl,%slot)
{
	%pl.setImageLoaded(%slot,1);
}
function ar15Image::onRelease(%db,%pl,%slot)
{
	sWeps_loopingAudioEnd(%db,%pl,%slot,ar15FireLoopEndSound);
}
function ar15Image::onDryFire(%db,%pl,%slot)
{
	sWeps_loopingAudioEnd(%db,%pl,%slot,ar15FireLoopEndSound);
	sWeps_displayNotif(%pl,"warn");
	serverPlay3D(ar15DryFireSound,%pl.getPosition());
}
function ar15Image::onUnMount(%db,%pl,%slot)
{
	sWeps_loopingAudioEnd(%db,%pl,%slot,ar15FireLoopEndSound);
	parent::onUnMount(%db,%pl,%slot);
}