datablock explosionData(dbShotgunExplosion : gunExplosion)
{
	soundProfile = "";
	particleEmitter = "";
};
datablock ProjectileData(cShotgunProjectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 14;
	explosion 				= dbShotgunExplosion;
	directDamageType    	= $DamageType::CShotgun;
	radiusDamageType    	= $DamageType::CShotgun;
	particleEmitter     	= sWepBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	sProjectile = 1;
	sShotgunProj = 1;
	sDamageFalloff = 1;
};
datablock AudioProfile(cShotgunFireSound)
{
	filename    = "./sound/cs_fire.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(cShotgunPumpSound : cShotgunFireSound)
{
	filename    = "./sound/cs_pump.wav";
	description = AudioClose3d;
};
datablock AudioProfile(cShotgunLoadSound : cShotgunFireSound)
{
	filename    = "./sound/cs_load.wav";
	description = AudioClosest3d;
};
if($Pref::Swol_CreateFakeIcons)
{
	datablock ItemData(cShotgunIcon)
	{
		iconName = "./model/icon/icon_cshotgun";
		uiName = "Combat Shotgun";
	};
}
datablock ItemData(cShotgunItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./model/c_shotgun_v3.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Combat Shotgun";
	iconName = "./model/icon/icon_cshotgun";
	fakeIcon = cShotgunIcon;
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1";
	ammo = " ";
	isLargeWeapon = 1;
	backImage = cShotgunBackImage;
	
	image = cShotgunImage;
	canDrop = true;
	
	sAmmoType = "shotgun_shells";
	sAmmo = 6;
	sAmmoShellReload = 1;
};
datablock ShapeBaseImageData(cShotgunBackImage)
{
	shapeFile = "./model/c_shotgun_v3.dts";
	emap = true;
	mountPoint = $backslot;
	offset = "0.6 -0.35 0.4";
	rotation = eulerToMatrix("-65 0 90");
	
	item = cShotgunItem;
	eyeOffset = "0 0 -999";
	
	doColorShift = true;
	colorShiftColor = cShotgunItem.colorShiftColor;
};
datablock ShapeBaseImageData(cShotgunImage)
{
	className = "WeaponImage";
	shapeFile = "./model/c_shotgun_v3.dts";
	emap = true;
	mountPoint = 0;
	offset = "-0.014 -0.15 -0.2";
	item = cShotgunItem;
	ammo = " ";
	projectile = cShotgunProjectile;
	projectileSpread = 0.09;
	projectileCnt = 14;
	projectileType = Projectile;
	
	casing = shotgunShellDebris;
	shellExitDir        = "1.2 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = true;
	colorShiftColor = cShotgunItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Release";
	
	stateName[1]					= "Release";
	stateSequence[1]				= "root";
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTriggerUp[1]	= "Idle";
	
	stateName[2]					= "Idle";
	stateTransitionOnNotLoaded[2]	= "StartLoading";
	stateTransitionOnTriggerDown[2]	= "FireCheckA";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Trigger";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Trigger";
	stateSequence[5]				= "trig";
	stateScript[5]					= "onTrigger";
	stateTimeoutValue[5]			= 0.02;
	stateSound[5]					= dbShotgunTrigSound;
	stateTransitionOnTimeout[5] 	= "Fire";
	
	stateName[6]					= "Fire";
	stateScript[6]					= "onFire";
	stateEmitter[6]					= gunFlashEmitter;
	stateEmitterTime[6]				= 0.05;
	stateSequence[6]				= "untrig";
	stateEmitterNode[6]				= "muzzlePoint";
	stateTransitionOnTimeout[6]     = "Smoke";
	stateTimeoutValue[6]            = 0.14;
	
	stateName[7] 					= "Smoke";
	stateEmitter[7]					= sWepsGunSmokeEmitter;
	stateEmitterTime[7]				= 0.05;
	stateEmitterNode[7]				= "muzzlePoint";
	stateTimeoutValue[7]            = 0.3;
	stateTransitionOnTimeout[7]     = "PumpA";
	
	stateName[8]					= "Wait";
	stateScript[8]					= "onWait";
	stateTimeoutValue[8]			= 0.1;
	stateTransitionOnTimeout[8]		= "Release";
	
	stateName[9]					= "DryFire";
	stateSequence[9]				= "trig";
	stateScript[9]					= "onTrigger";
	stateTimeoutValue[9]			= 0.05;
	stateSound[9]					= dbShotgunTrigSound;
	stateTransitionOnTimeout[9] 	= "UnDryFire";
	
	stateName[10]					= "PumpA";
	stateSequence[10]				= "pumpA";
	stateTimeoutValue[10]			= 0.2;
	stateScript[10]					= "onPumpA";
	stateTransitionOnTimeout[10]	= "PumpB";
	
	stateName[11]					= "PumpB";
	stateSequence[11]				= "pumpB";
	stateScript[11]					= "onPumpB";
	stateEjectShell[11]				= true;
	stateTimeoutValue[11]			= 0.2;
	stateTransitionOnTimeout[11]	= "Wait";
	
	stateName[12]					= "LoadCheckA";
	stateScript[12]					= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]	= "LoadA";
	
	stateName[13]					= "LoadCheckB";
	stateTransitionOnLoaded[13]		= "StopLoading";
	stateTransitionOnNotLoaded[13]	= "LoadCheckA";
	
	stateName[14]					= "LoadA";
	stateScript[14]					= "onLoad";
	stateTimeoutValue[14]			= 0.15;
	stateSequence[14]				= "load";
	stateTransitionOnTimeout[14]	= "LoadB";
	
	stateName[15]					= "LoadB";
	stateTimeoutValue[15]			= 0.1;
	stateTransitionOnTimeout[15]	= "LoadC";
	
	stateName[16]					= "LoadC";
	stateTransitionOnTriggerDown[16]= "StopLoading";
	stateTimeoutValue[16]			= 0.12;
	stateTransitionOnTimeout[16]	= "LoadCheckB";
	
	stateName[17]					= "UnDryFire";
	stateSequence[17]				= "untrig";
	stateTimeoutValue[17]			= 0.04;
	stateTransitionOnTimeout[17]	= "Wait";
	
	stateName[18]					= "StopLoading";
	stateDirection[18]				= 0;
	stateSequence[18]				= "root";
	stateScript[18]					= "onStopLoading";
	stateTimeoutValue[18]			= 0.01;
	stateTransitionOnTimeout[18]	= "Idle";
	
	stateName[19]					= "StartLoading";
	stateSequence[19]				= "root";
	stateScript[19]					= "onStartLoading";
	stateTimeoutValue[19]			= 0.01;
	stateTransitionOnTimeout[19]	= "LoadCheckA";
};
function cShotgunImage::onLoad(%db,%pl,%slot)
{
	serverPlay3D(cShotgunLoadSound,%pl.getPosition());
	%pl.playThread(2,shiftRight);
	if(sAmmo_rCheck(%db,%pl,%slot) > 0 && sAmmo_check(%db,%pl,%slot) < %db.item.sAmmo)
	{
		sAmmo_rDec(%db,%pl,%slot);
		sAmmo_load(%db,%pl,%slot,sAmmo_check(%db,%pl,%slot)+1);
	}
}
function cShotgunImage::onStartLoading(%db,%pl,%slot)
{
	//%pl.playThread(2,shiftRight);
	%pl.setImageLoaded(%slot,0);
}
function cShotgunImage::onStopLoading(%db,%pl,%slot)
{
	//%pl.playThread(2,shiftLeft);
	%pl.setImageLoaded(%slot,1);
	if(sAmmo_check(%db,%pl,%slot) > 0)
		%pl.setImageAmmo(%slot,1);
}
function cShotgunImage::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	serverPlay3D(cShotgunFireSound,%pl.getPosition());
	%val = sAmmo_dec(%db,%pl,%slot);
	%setNum = getRandom(0,99999);
	%p = sWeps_fire(%db,%pl,%slot,"","80 120");
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
		
	%pl.sWeps_fireDelay[%db] = getSimTime()+540;
}
function cShotgunImage::onTrigger(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	if(!sAmmo_check(%db,%pl,%slot))
		sWeps_displayNotif(%pl,"warn");
}
function cShotgunImage::onPumpA(%db,%pl,%slot)
{
	%pl.schedule(50,playThread,2,plant);
	serverPlay3D(cShotgunPumpSound,%pl.getPosition());
	schedule(getRandom(400,500),0,serverPlay3D,dbShotgunShellDrop @ getRandom(1,2) @ Sound,%pl.getPosition());
}
function cShotgunImage::onWait(%db,%pl,%slot)
{

}
function cShotgunImage::onLoadCheck(%db,%pl,%slot)
{
	if(sAmmo_check(%db,%pl,%slot) < %db.item.sAmmo-1)
	{
		if(($Pref::Swol_ReserveAmmo == 1 && sAmmo_rCheck(%db,%pl,%slot) <= 1))
		{
			%pl.setImageLoaded(%slot,1);
		}
		else
		{
			%pl.setImageLoaded(%slot,0);
		}
	}
	else
	{
		%pl.setImageLoaded(%slot,1);
	}
}
function cShotgunImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}