datablock explosionData(dbShotgunExplosion : gunExplosion)
{
	soundProfile = "";
	particleEmitter = "";
};
datablock ProjectileData(dbShotgunProjectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 12;
	explosion 				= dbShotgunExplosion;
	directDamageType    	= $DamageType::DBShotgun;
	radiusDamageType    	= $DamageType::DBShotgun;
	particleEmitter     	= sWepBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	sProjectile = 1;
	sShotgunProj = 1;
};

datablock AudioProfile(dbShotgunBlastSound)
{
	filename    = "./sound/db_fire.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(dbShotgunBreakSound : dbShotgunBlastSound)
{
	filename    = "./sound/db_break.wav";
};
datablock AudioProfile(dbShotgunUnBreakSound : dbShotgunBlastSound)
{
	filename    = "./sound/db_unbreak.wav";
};
datablock AudioProfile(dbShotgunLoadSound : dbShotgunBlastSound)
{
	filename    = "./sound/db_load.wav";
};
datablock AudioProfile(dbShotgunTrigSound : dbShotgunBlastSound)
{
	filename    = "./sound/db_trig.wav";
};
datablock AudioProfile(dbShotgunShellDrop1Sound : dbShotgunBlastSound)
{
	filename    = "./sound/db_shellDrop1.wav";
	description = AudioClose3d;
};
datablock AudioProfile(dbShotgunShellDrop2Sound : dbShotgunBlastSound)
{
	filename    = "./sound/db_shellDrop2.wav";
	description = AudioClose3d;
};
datablock AudioProfile(shotgunHitPl1Sound : dbShotgunBlastSound)
{
	filename    = "./sound/db_hitPl1.wav";
};
datablock AudioProfile(shotgunHitPl2Sound : dbShotgunBlastSound)
{
	filename    = "./sound/db_hitPl2.wav";
};
datablock AudioProfile(shotgunHitPl3Sound : dbShotgunBlastSound)
{
	filename    = "./sound/db_hitPl3.wav";
};
datablock DebrisData(shotgunShellDebris)
{
	shapeFile = "./model/shell_shotgun.dts";
	lifetime = 6.0;
	lifetimeVariance = 1.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
if($Pref::Swol_CreateFakeIcons)
{
	datablock ItemData(dbShotgunIcon)
	{
		iconName = "./model/icon/icon_dbshotgun";
		uiName = "DB Shotgun";
	};
}
datablock ItemData(dbShotgunItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./model/db_shotgun_v2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "DB Shotgun";
	iconName = "./model/icon/icon_dbshotgun";
	fakeIcon = dbShotgunIcon;
	doColorShift = true;
	colorShiftColor = "0.57 0.35 0.2 1";
	ammo = 1;
	isLargeWeapon = 1;
	backImage = dbShotgunBackImage;
	
	image = dbShotgunImage;
	canDrop = true;
	
	sAmmoType = "shotgun_shells";
	sAmmo = 2;
};
datablock ShapeBaseImageData(dbShotgunBackImage)
{
	shapeFile = "./model/db_shotgun_v2.dts";
	emap = true;
	mountPoint = $backslot;
	offset = "0.6 -0.35 0.4";
	rotation = eulerToMatrix("-65 0 90");
	
	item = dbShotgunItem;
	eyeOffset = "0 0 -999";
	
	doColorShift = true;
	colorShiftColor = dbShotgunItem.colorShiftColor;
};
datablock ShapeBaseImageData(dbShotgunImage)
{
	className = "WeaponImage";
	shapeFile = "./model/db_shotgun_v2.dts";
	emap = true;
	mountPoint = 0;
	offset = "-0.014 0 -0.08";
	item = dbShotgunItem;
	ammo = " ";
	projectile = dbShotgunProjectile;
	projectileSpread = 0.2;
	projectileCnt = 30;
	projectileType = Projectile;
	
	casing = shotgunShellDebris;
	shellExitDir        = "0.2 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = true;
	colorShiftColor = dbShotgunItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Release";
	
	stateName[1]					= "Release";
	stateSequence[1]				= "root";
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTriggerUp[1]	= "Idle";
	
	stateName[2]					= "Idle";
	stateTransitionOnNotLoaded[2]	= "Break";
	stateTransitionOnTriggerDown[2]	= "FireCheckA";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Trigger";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Trigger";
	stateSequence[5]				= "trig";
	stateScript[5]					= "onTrigger";
	stateTimeoutValue[5]			= 0.02;
	stateSound[5]					= dbShotgunTrigSound;
	stateTransitionOnTimeout[5] 	= "Fire";
	
	stateName[6]					= "Fire";
	stateScript[6]					= "onFire";
	stateEmitter[6]					= gunFlashEmitter;
	stateEmitterTime[6]				= 0.05;
	stateSequence[6]				= "untrig";
	stateEmitterNode[6]				= "muzzlePoint";
	stateTransitionOnTimeout[6]     = "X";
	stateTimeoutValue[6]            = 0.14;
	
	stateName[7] 					= "Smoke";
	stateEmitter[7]					= sWepsGunSmokeEmitter;
	stateEmitterTime[7]				= 0.05;
	stateEmitterNode[7]				= "muzzlePoint";
	stateTimeoutValue[7]            = 0.3;
	stateTransitionOnTimeout[7]     = "Wait";
	
	stateName[8]					= "Wait";
	stateTimeoutValue[8]			= 0.3;
	stateTransitionOnTimeout[8]		= "Release";
	
	stateName[9]					= "DryFire";
	stateSequence[9]				= "trig";
	stateScript[9]					= "onTrigger";
	stateTimeoutValue[9]			= 0.05;
	stateSound[9]					= dbShotgunTrigSound;
	stateTransitionOnTimeout[9] 	= "UnDryFire";
	
	stateName[10]					= "Break";
	stateSequence[10]				= "break";
	stateTimeoutValue[10]			= 0.2;
	stateScript[10]					= "onBreak";
	stateTransitionOnTimeout[10]	= "UnloadA";
	
	stateName[11]					= "UnloadA";
	stateSequence[11]				= "unload";
	stateScript[11]					= "onUnload";
	stateTimeoutValue[11]			= 0.01;
	stateEjectShell[11]				= true;
	stateTransitionOnTimeout[11]	= "UnloadB";
	
	stateName[12]					= "UnloadB";
	stateTimeoutValue[12]			= 0.4;
	stateEjectShell[12]				= true;
	stateTransitionOnTimeout[12]	= "LoadA";
	
	stateName[13]					= "LoadA";
	stateSequence[13]				= "lload";
	stateScript[13]					= "onLoad";
	stateTimeoutValue[13]			= 0.01;
	stateTransitionOnTimeout[13]	= "LoadB";
	
	stateName[14]					= "LoadB";
	stateTimeoutValue[14]			= 0.3;
	stateTransitionOnTimeout[14]	= "LoadC";
	
	stateName[15]					= "LoadC";
	stateSequence[15]				= "rload";
	stateScript[15]					= "onLoad";
	stateTimeoutValue[15]			= 0.01;
	stateTransitionOnTimeout[15]	= "LoadD";
	
	stateName[16]					= "LoadD";
	stateTimeoutValue[16]			= 0.3;
	stateTransitionOnTimeout[16]	= "UnBreak";
	
	stateName[17]					= "UnBreak";
	stateSequence[17]				= "unbreak";
	stateTimeoutValue[17]			= 0.2;
	stateScript[17]					= "onUnBreak";
	stateTransitionOnTimeout[17]	= "Wait";
	
	stateName[18]					= "UnDryFire";
	stateSequence[18]				= "untrig";
	stateTimeoutValue[18]			= 0.04;
	stateTransitionOnTimeout[18]	= "Wait";
	
	stateName[19]					= "SpinCock";
	stateSequence[19]				= "spinCock";
	stateTimeoutValue[19]			= 0.5;
	stateScript[19]					= "onSpinCock";
	stateEmitter[19]				= sWepsGunSmokeEmitter;
	stateEmitterTime[19]			= 0.05;
	stateEmitterNode[19]			= "muzzlePoint";
	stateTransitionOnTimeout[19]	= "WaitB";
	
	stateName[20]					= "X";
	stateTransitionOnAmmo[20]		= "Smoke";
	stateTransitionOnNoAmmo[20]		= "SpinCock";
	
	stateName[21]					= "WaitB";
	stateTimeoutValue[21]			= 0.1;
	stateTransitionOnTimeout[21]	= "Release";
	
};
function dbShotgunImage::onLoad(%db,%pl,%slot)
{
	serverPlay3D(dbShotgunLoadSound,%pl.getPosition());
	%pl.playThread(2,shiftLeft);
	if(sAmmo_rCheck(%db,%pl,%slot) > 0 && sAmmo_check(%db,%pl,%slot) < %db.item.sAmmo)
	{
		sAmmo_rDec(%db,%pl,%slot);
		sAmmo_load(%db,%pl,%slot,sAmmo_check(%db,%pl,%slot)+1);
	}
}
function dbShotgunImage::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	serverPlay3D(dbShotgunBlastSound,%pl.getPosition());
	%val = sAmmo_dec(%db,%pl,%slot);
	%p = sWeps_fire(%db,%pl,%slot,"","80 150");
	if(%val == 1 && !getRandom(0,2))
		%pl.setImageAmmo(%slot,0);
		
	%pl.sWeps_fireDelay[%db] = getSimTIme()+740;
}
function dbShotgunImage::onTrigger(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	if(!sAmmo_check(%db,%pl,%slot))
		sWeps_displayNotif(%pl,"warn");
}
function dbShotgunImage::onUnload(%db,%pl,%slot)
{
	sWeps_display(%pl,0);
}
function dbShotgunImage::onBreak(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	serverPlay3D(dbShotgunBreakSound,%pl.getPosition());
	
	schedule(getRandom(600,700),0,serverPlay3D,dbShotgunShellDrop @ getRandom(1,2) @ Sound,%pl.getPosition());
}
function dbShotgunImage::onUnBreak(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	serverPlay3D(dbShotgunUnBreakSound,%pl.getPosition());
	%pl.setImageLoaded(%slot,1);
}
function dbShotgunImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function dbShotgunImage::onSpinCock(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	%pl.schedule(220,playThread,3,shiftTo);
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}

function swol_fuckBlockland_fixMYGodamnShotgun() //some sort of string overload bullshit SO LIKE HERE LKGFDJDFLKGJFDLKGJ, this was coded when i was drunk as fuck (6/2/2019)
{
	dbShotgunImage.colorShiftColor = dbShotgunItem.colorShiftColor;
	eval("function swol_fuckBlockland_fixMYGodamnShotgun(){}");
}
schedule(1,0,swol_fuckBlockland_fixMYGodamnShotgun);