function serverCmdSWepsSendDataLine(%cl,%ctrl,%target,%pref,%val)
{
	if(!%cl.isAdmin)
		return;
	switch$(%ctrl)
	{
		case "s":
			echo("Recieving Data");
		case "e":
			echo("Ending Data");
			SWepsPrefs_cleanChanges();
		case "dw":
			SWepsPrefs_AssignPref(%target,%pref,%val);
	}
}
function SWepsPrefs_varToPrefName(%var)
{
	switch$(%var)
	{
		case "sAmmo":				return "Ammo Amount";
		case "sHeat":				return "Weapon Heat";
		case "projectileCnt":		return "Projectile Count";
		case "projectileSpread":	return "Projectile Spread" TAB 1;
		case "projectileHeatSpread":return "Projectile Heat Spread" TAB 1;
		case "projectileSpeed":		return "Projectile Speed";
		case "directDamage":		return "Projectile Damage";
		case "headshotDamage":		return "Headshot Damage";
	}
}
function SWepsPrefs_prefNameToVar(%pref,%item)
{
	switch$(%pref)
	{
		case "Ammo Amount":
			%varName = "sAmmo";
			%target = %item;
		case "Weapon Heat":
			%varName = "sHeat";
			%target = %item;
		case "Projectile Count":
			%varName = "projectileCnt";
			%target = %item.image;
		case "Projectile Spread":
			%varName = "projectileSpread";
			%target = %item.image;
			%mod = 1;
		case "Projectile Heat Spread":
			%varName = "projectileHeatSpread";
			%target = %item.image;
			%mod = 1;
		case "Projectile Speed":
			%varName = "projectileSpeed";
			%target = %item.image;
		case "Projectile Damage":
			%varName = "directDamage";
			%target = %item.image.projectile;
		case "Headshot Damage":
			%varName = "headshotDamage";
			%target = %item.image.projectile;
	}
	return %varName TAB %target TAB %mod;
}
function SWepsPrefs_AssignPref(%target,%pref,%val)
{
	%item = $SWeps_UiToId[getSafeVariableName(%target)];
	echo(%target @ ">" @ %pref @ ": " @ %val);
	
	%data = SWepsPrefs_prefNameToVar(%pref,%item);
	%varName = getField(%data,0);
	%target = getField(%data,1);
	%mod = getField(%data,2);
	echo(%data);
	if(%varName !$= "")
	{
		%oldVal = %val;
		if(%mod)
			%val = ((%val/2)*$PI)/180;

		%backupVal = SWepsPrefs_getVarStr(%target,%varName);
		%defaultVal = %target.sWepsBackup[%varName];
		
		SWepsPrefs_setVarStr(%target,%varName,%val);
		SWepsPrefs_changeValMessage(%item,%varName,%backupVal,%val);
		%fp = new fileObject($Pref::Swol_SWepsPrefChangesFile);
		%fp.openForAppend($Pref::Swol_SWepsPrefChangesFile);
		%fp.writeLine(%target.getName() @ "." @ %varName @ "=" @ %val @ "; //changed from " @ %defaultVal);
		%fp.close();
		%fp.delete();
	}
}
function SWepsPrefs_changeValMessage(%item,%var,%old,%new,%type)
{
	%data = SWepsPrefs_varToPrefName(%var);
	%prefName = getField(%data,0);
	%mod = getField(%data,1);
	if(%mod)
	{
		%new = ((%new*180)/$PI)*2;
		%old = ((%old*180)/$PI)*2;
	}
	messageAll('',"<color:ffaaff>" @ %item.uiName @ "|" @ %prefName @ "\c5 " @ (!%type ? "changed" : "defaulted") @ " \c3" @ %old @ " \c5 -> \c3" @ %new);
}
function SWepsPrefs_latchDefaultValues(%x) //if you're reading this fuck you
{
	%l["ItemData"] = "sAmmo sHeat";
	%l["ShapeBaseImageData"] = "projectileSpeed projectileCnt projectileSpread projectileHeatSpread";
	%l["ProjectileData"] = "directDamage headshotDamage";
	
	for(%cnt=datablockGroup.getCount();%i<%cnt;%i++)
	{
		if((%o=datablockGroup.getObject(%i)).sAmmo && (%j=%o.className) $= "Weapon")
		{
			while(%j++<4)
			{
				switch(%j)
				{
					case 1: %t = %o;
					case 2: %t = %o.image;
					case 3: %t = %o.image.projectile;
				}
				if(!isObject(%t))
					continue;
				if(!%wc[%c=%t.getClassName()]*1)
					%wc[%c] = getWordCount(%l[%c]);
				for(%k=0;%k<%wc[%c];%k++)
				{
					if(!%x)
					{
						if((%v=SWepsPrefs_getVarStr(%t,%w=getWord(%l[%c],%k))) !$= "")
							%t.sWepsBackup[%w] = %v;
					}
					else
					{
						if((%v=%t.sWepsBackup[%w=getWord(%l[%c],%k)]) !$= "")
						{
							if(%v !$= (%q = SWepsPrefs_getVarStr(%t,%w)))
							{
								SWepsPrefs_changeValMessage(%o,%w,%q,%v);
								SWepsPrefs_setVarStr(%t,%w,%v);
							}
						}
					}
				}
			}
		}
	}
	if(!%x)
		echo("Latched default SWep Values");
	return 1;
}
function SWepsPrefs_cleanChanges(%stage,%tick,%tmp)
{
	cancel($SWepsFunc_sched);
	if(%stage == 0)
	{
		$SWepsFunc_fp = new fileObject();
		$SWepsFunc_fp.openForRead($Pref::Swol_SWepsPrefChangesFile);
		$SWepsFunc_lineCnt = 0;
		$SWepsFunc_remLine = 0;
		%stage++;
	}
	if(%stage == 1)
	{
		while(!(%eof = $SWepsFunc_fp.isEOF()) && %tick < 60)
		{
			$SWepsFunc_line[$SWepsFunc_lineCnt] = $SWepsFunc_fp.readLine();
			$SWepsFunc_lineCnt++;
			%tick++;
		}
		if(%eof)
		{
			$SWepsFunc_fp.close();
			$SWepsFunc_fp.delete();
			%tmp = $SWepsFunc_lineCnt;
			%stage++;
		}
	}
	if(%stage == 2)
	{
		$SWepsFunc_doClean = false;
		$SWepsFunc_newLineCnt = 0;
		while(%tmp-->=0 && %tick < 60)
		{
			%line = $SWepsFunc_line[%tmp];
			echo(%line);
			if(%line $= "")
			{
				$SWepsFunc_doClean = true;
				$SWepsFunc_remLine++;
				continue;
			}
			%upTo = strReplace(getSubStr(%line,0,strPos(%line,"=")),".","_");
			if($SWepsFunc_has[%upTo])
			{
				$SWepsFunc_doClean = true;
				$SWepsFunc_remLine++;
				%pass = false;
			}
			else
			{
				%pivotA = strPos(%line,".");
				%pivotB = strPos(%line,"=");
				%pivotC = strPos(%line,";");
				%pass = true;
				if(%pivotA == -1 || %pivotB == -1 || %pivotC == -1)
				{
					$SWepsFunc_doClean = true;
					$SWepsFunc_remLine++;
					%pass = false;
				}
				else if(%pivotA+1 == %pivotB || %pivotB+1 == %pivotC)
				{
					$SWepsFunc_doClean = true;
					$SWepsFunc_remLine++;
					%pass = false;
				}
				else
				{
					%item = getSubStr(%line,0,%pivotA);
					%var = getSubStr(%line,%pivotA+1,%pivotB-(%pivotA+1));
					%val = getSubStr(%line,%pivotB+1,%pivotC-(%pivotB+1));
					if($SWepsFunc_clearAllOf[%item,%var])
					{
						$SWepsFunc_doClean = true;
						$SWepsFunc_remLine++;
						%pass = false;
					}
					else if(isObject(%item))
					{
						if((%default = %item.sWepsBackup[%var]) !$= "")
						{
							if(%default $= %val)
							{
								$SWepsFunc_clearAllOf[%item,%var] = 1;
								$SWepsFunc_doClean = true;
								$SWepsFunc_remLine++;
								%pass = false;
							}
						}
					}
				}
				
				if(%pass)
				{
					echo("ADDED [" @ $SWepsFunc_newLineCnt @ "]" @ %line);
					$SWepsFunc_lineN[$SWepsFunc_newLineCnt] = %line;
					$SWepsFunc_newLineCnt++;
					$SWepsFunc_has[%upTo] = true;
				}
			}
			%tick++;
		}
		if(%tmp <= 0)
		{
			%stage++;
		}
	}
	if(%stage == 3)
	{
		if(!$SWepsFunc_doClean)
		{
			%stage = 5;
		}
		else
		{
			$SWepsFunc_fp = new fileObject();
			$SWepsFunc_fp.openForWrite($Pref::Swol_SWepsPrefChangesFile);
			%tmp = $SWepsFunc_newLineCnt;
			%stage++;
		}
	}
	if(%stage == 4)
	{
		while(%tmp-->=0 && %tick < 60)
		{
			echo("TMP VAL " @ %tmp SPC $SWepsFunc_lineN[%tmp]);
			$SWepsFunc_fp.writeLine($SWepsFunc_lineN[%tmp]);
			%tick++;
		}
		if(%tmp <= 0)
		{
			$SWepsFunc_fp.close();
			$SWepsFunc_fp.delete();
			%stage++;
		}
	}
	if(%stage == 5)
	{
		if(!$SWepsFunc_doClean)
		{
			echo("Clean check complete, nothing to clean");
		}
		else
		{
			echo("Clean complete. " @ $SWepsFunc_remLine @ " line" @ ($SWepsFunc_remLine == 1 ? "" : "s") @ " removed");
			if($SWepsFunc_newLineCnt == 0)
			{
				fileDelete($Pref::Swol_SWepsPrefChangesFile);
			}
		}
		deleteVariables("$SWepsFunc_*");
		return;
	}
	$SWepsFunc_sched = schedule(32,0,SWepsPrefs_cleanChanges,%stage,%tick,%tmp);
}
function SWepsPrefs_getVarStr(%obj,%str)
{
	%first = getSubStr(%str,0,1);
	%rest = getSubStr(%str,1,99);
	switch$(%first)
	{
		case "_": return %obj._[%rest];
		case "a": return %obj.a[%rest];
		case "b": return %obj.b[%rest];
		case "c": return %obj.c[%rest];
		case "d": return %obj.d[%rest];
		case "e": return %obj.e[%rest];
		case "f": return %obj.f[%rest];
		case "g": return %obj.g[%rest];
		case "h": return %obj.h[%rest];
		case "i": return %obj.i[%rest];
		case "j": return %obj.j[%rest];
		case "k": return %obj.k[%rest];
		case "l": return %obj.l[%rest];
		case "m": return %obj.m[%rest];
		case "n": return %obj.n[%rest];
		case "o": return %obj.o[%rest];
		case "p": return %obj.p[%rest];
		case "q": return %obj.q[%rest];
		case "r": return %obj.r[%rest];
		case "s": return %obj.s[%rest];
		case "t": return %obj.t[%rest];
		case "u": return %obj.u[%rest];
		case "v": return %obj.v[%rest];
		case "w": return %obj.w[%rest];
		case "x": return %obj.x[%rest];
		case "y": return %obj.y[%rest];
		case "z": return %obj.z[%rest];
	}
}
function SWepsPrefs_setVarStr(%obj,%str,%val)
{
	%first = getSubStr(%str,0,1);
	%rest = getSubStr(%str,1,99);
	switch$(%first)
	{
		case "_": %obj._[%rest] = %val;
		case "a": %obj.a[%rest] = %val;
		case "b": %obj.b[%rest] = %val;
		case "c": %obj.c[%rest] = %val;
		case "d": %obj.d[%rest] = %val;
		case "e": %obj.e[%rest] = %val;
		case "f": %obj.f[%rest] = %val;
		case "g": %obj.g[%rest] = %val;
		case "h": %obj.h[%rest] = %val;
		case "i": %obj.i[%rest] = %val;
		case "j": %obj.j[%rest] = %val;
		case "k": %obj.k[%rest] = %val;
		case "l": %obj.l[%rest] = %val;
		case "m": %obj.m[%rest] = %val;
		case "n": %obj.n[%rest] = %val;
		case "o": %obj.o[%rest] = %val;
		case "p": %obj.p[%rest] = %val;
		case "q": %obj.q[%rest] = %val;
		case "r": %obj.r[%rest] = %val;
		case "s": %obj.s[%rest] = %val;
		case "t": %obj.t[%rest] = %val;
		case "u": %obj.u[%rest] = %val;
		case "v": %obj.v[%rest] = %val;
		case "w": %obj.w[%rest] = %val;
		case "x": %obj.x[%rest] = %val;
		case "y": %obj.y[%rest] = %val;
		case "z": %obj.z[%rest] = %val;
	}
}
function serverCmdSWepsRequestData(%cl)
{
	if(!%cl.isAdmin)
		return;
	SWepsPrefs_sendAllData(%cl);
}
function serverCmdSWepsResetVariables(%cl)
{
	if(!%cl.isSuperAdmin)
		return;
	SWepsPrefs_latchDefaultValues(1);
	serverCmdSWepsRequestData(%cl);
}
function SWepsPrefs_execPrefs()
{
	if(!isFile($Pref::Swol_SWepsPrefChangesFile))
		return;

	if(!$SWepsPrefs_HasLatchedDefaultData)
		$SWepsPrefs_HasLatchedDefaultData = SWepsPrefs_latchDefaultValues();

	exec($Pref::Swol_SWepsPrefChangesFile);
}
function SWepsPrefs_sendAllData(%cl)
{
	if(!$SWepsPrefs_HasLatchedDefaultData)
		$SWepsPrefs_HasLatchedDefaultData = SWepsPrefs_latchDefaultValues();

	SWepsPrefs_sendCtrl(%cl,"clear");
	SWepsPrefs_sendAmmoVars(%cl);
	%cnt = datablockGroup.getCount();
	%amt = 0;
	for(%i=0;%i<%cnt;%i++)
	{
		%obj = datablockGroup.getObject(%i);
		if(%obj.getClassName() $= "ItemData")
		{
			if(%obj.uiName $= "")
				continue;
			if(%obj.sAmmo !$= "")
			{
				if(%obj.isAmmo)
				{
					if(!%obj.notJustAnAlt)
					{
						if(%hasSentAmmo[%obj.sAmmoType])
							continue;
						%hasSentAmmo[%obj.sAmmoType] = 1;
					}
				}
				%item[%amt] = %obj;
				%amt++;
			}
		}
	}
	%list = new GuiTextListCtrl();
	for(%i=0;%i<%amt;%i++)
	{
		%item = %item[%i];
		%pre = "";
		if(%item.weaponClass $= "slot3")
			%pre = "zzzz";
		if(%item.isAmmo)
		{
			%pre = swolammo_getName(%item.sAmmoType);
			if(%item.notJustAnAlt)
			{
				%pre = %pre @ "z";
			}
		}
		%list.addRow(%i,%item TAB %pre @ %item.uiName);
	}
	%list.sort(1,1);
	for(%i=0;%i<%amt;%i++)
	{
		%item = getField(%list.getRowText(%i),0);
		%val = getField(%list.getRowText(%i),1);
		SWepsPrefs_sendItem(%cl,%item);
	}
	%list.delete();
	SWepsPrefs_sendCtrl(%cl,"pref","$Pref::Swol_ReserveAmmo","Reserve Ammo",$Pref::Swol_ReserveAmmo,"c");
	SWepsPrefs_sendCtrl(%cl,"pref","$Pref::Swol_NoAmmo","No Ammo",$Pref::Swol_NoAmmo,"c");
	SWepsPrefs_sendCtrl(%cl,"pref","$Pref::Swol_SWepsBlood","Blood",$Pref::Swol_SWepsBlood,"c");
	SWepsPrefs_sendCtrl(%cl,"pref","$Pref::Swol_SWepsDamageFalloffDist","Dmg Falloff Distance",$Pref::Swol_SWepsDamageFalloffDist,"t 0 500");
	SWepsPrefs_sendCtrl(%cl,"done");
}
function SWepsPrefs_sendCtrl(%cl,%ctrl,%a,%b,%c,%d)
{
	commandToClient(%cl,'SWepsPrefs_dataLine',%ctrl,%a,%b,%c,%d);
}
function SWepsPrefs_sendAmmoVars(%cl)
{
	%cnt = swolammo_getCount();
	for(%i=0;%i<%cnt;%i++)
	{
		%var = swolammo_getAmmo(%i);
		%name = swolammo_getName(%var);
		%spawn = swolammo_getSpawn(%var);
		%max = swolammo_getMax(%var);
		commandToClient(%cl,'SWepsPrefs_dataLine',"ammoVar",%var,%name,%spawn,%max);
	}
}
function SWepsPrefs_sendItem(%cl,%item)
{
	%name = %item.uiName;
	%icon = %item.iconName;
	if(%item.isAmmo)
	{
		$SWeps_UiToId[getSafeVariableName(%item.uiName)] = %item;
		%name = strReplace(%name,"Ammo ","");
		%ctrl = "ammo";
		%c = %item.sAmmoType;
		%d = %item.sAmmo;
	}
	else
	{
		$SWeps_UiToId[getSafeVariableName(%item.uiName)] = %item;
		%c = %item.sAmmoType;
		%d = %item.sAmmo TAB %item.sWepsBackup["sAmmo"];
		%e = %item.image.projectileSpread TAB %item.image.sWepsBackup["projectileSpread"];
		%f = %item.image.projectileHeatSpread TAB %item.image.sWepsBackup["projectileHeatSpread"];
		%g = %item.image.projectileCnt TAB %item.image.sWepsBackup["projectileCnt"];
		%h = %item.image.projectileSpeed TAB %item.image.sWepsBackup["projectileSpeed"];
		%i = %item.image.projectile.directDamage TAB %item.image.projectile.sWepsBackup["directDamage"];
		%j = %item.image.projectile.headshotDamage  TAB %item.image.projectile.sWepsBackup["headshotDamage"];
		%k = %item.sHeat TAB %item.sWepsBackup["sHeat"];
		%ctrl = "wep";
	}
	commandToClient(%cl,'SWepsPrefs_dataLine',%ctrl,%name,%icon,%c,%d,%e,%f,%g,%h,%i,%j,%k);
}


function player::zoomAnim(%pl,%start,%end,%max,%tick)
{
	if(!isObject(%pl.client))
		return;
	cancel(%pl.zoomSched);
	%prcnt = %tick/%max;
	%diff = %end-%start;
	%step = %prcnt*%diff;
	%pl.client.setControlCameraFov(%start+%step);
	if(%tick >= %max)
		return;
	%pl.zoomSched = %pl.schedule(16,zoomAnim,%start,%end,%max,%tick++);
}
function sWeps_setScoped(%pl,%im,%bool,%override)
{
	if((%scoped = %im.item.scopedImage) !$= "")
	{
		if(!%bool)
		{
			%pl.isScoped = 0;
			//%pl.client.setControlCameraFov(%pl.preScopeZoom);
			if($Pref::Swol_SAmmo_ScopeZoom)
			{
				%pl.zoomAnim(%pl.getCameraFov(),%pl.client.savedFov,8,0);
			}
			if(%override $= "")
			{
				%pl.sAmmo_unscoping = 1;
				if(%im.item.unscopingImage !$= "")
					%pl.mountImage(%im.item.unscopingImage,0);
				else
					%pl.mountImage(%im.item.image,0);
					
				if(%pl.client && %pl.isFirstPerson())
					%pl.client.play2D(sniperScopeOutSound);
			}
			%pl.setMaxForwardSpeed(%pl.speedSave_forward);
			%pl.setMaxBackwardSpeed(%pl.speedSave_backward);
			%pl.setMaxSideSpeed(%pl.speedSave_side);
			%pl.setMaxCrouchForwardSpeed(%pl.speedSave_cforward);
			%pl.setMaxCrouchBackwardSpeed(%pl.speedSave_cbackward);
			%pl.setMaxCrouchSideSpeed(%pl.speedSave_cside);
		}
		else
		{
			%pl.isScoped = 1;
			if($Pref::Swol_SAmmo_ScopeZoom)
			{
				%pl.client.savedFov = %pl.getCameraFOV();
				%pl.zoomAnim(%pl.client.savedFov,%im.item.scopedZoom*%pl.client.savedFov,8,0);
			}
			//%pl.client.setControlCameraFov(%im.item.scopedZoom*%pl.preScopeZoom);
			if(%override $= "")
			{
				%pl.sAmmo_unscoping = 1;
				%pl.mountImage(%scoped,0);
				if(%pl.client && %pl.isFirstPerson())
					%pl.client.play2D(sniperScopeInSound);
			}
			%pl.speedSave_forward = %pl.getMaxForwardSpeed();
			%pl.speedSave_backward = %pl.getMaxBackwardSpeed();
			%pl.speedSave_side = %pl.getMaxSideSpeed();
			%pl.speedSave_cforward = %pl.getMaxCrouchForwardSpeed();
			%pl.speedSave_cbackward = %pl.getMaxCrouchBackwardSpeed();
			%pl.speedSave_cside = %pl.getMaxCrouchSideSpeed();
			%factor = %im.item.scopedSpeed;
			%pl.setMaxForwardSpeed(%pl.speedSave_forward*%factor);
			%pl.setMaxBackwardSpeed(%pl.speedSave_backward*%factor);
			%pl.setMaxSideSpeed(%pl.speedSave_side*%factor);
			%pl.setMaxCrouchForwardSpeed(%pl.speedSave_cforward*%factor);
			%pl.setMaxCrouchBackwardSpeed(%pl.speedSave_cbackward*%factor);
			%pl.setMaxCrouchSideSpeed(%pl.speedSave_cside*%factor);
		}
	}
}



function m60_getOpenDistantHandleIndx()
{
	for(%i=0;%i<$Swol_M60LoopingAudioSetCnt;%i++)
		if(!isObject($Swol_M60LoopingAudioSet[%i]))
			break;
	if(%i == $Swol_M60LoopingAudioSetCnt)
		$Swol_M60LoopingAudioSetCnt++;
	return %i;
}
function m60_createDistantHandle(%id)
{
	%set = $Swol_M60LoopingAudioSet[%id] = new simSet() { dclCnt = 0; demitterCnt = 0;};
	return %set;
}
function m60_destroyDistantHandle(%set)
{
	m60_clearDistantSound(%set);
	%set.pl.m60_distantHandle = "";
	%set.delete();
}
function m60_getOpenDistantSoundEmitterIndx(%set,%type)
{
	for(%i=0;%i<%set.d[%type @ "Cnt"];%i++)
		if(!isObject(%e = %set.d[%type @ %i]))
			break;
	if(%i == %set.d[%type @ "Cnt"])
		%set.d[%type @ "Cnt"]++;
	return %i;
}
function m60_iniDistantSound(%id,%sound,%pl,%range,%loop)
{
	if(%id $= "" || !isObject(%set = $Swol_M60LoopingAudioSet[%id]))
	{
		%id = m60_getOpenDistantHandleIndx();
		%set = m60_createDistantHandle(%id);
	}
	%pl.m60_distantHandle = %id;
	%set.range = %range;
	%set.isLoop = %loop;
	%set.pl = %pl;
	%set.volume = 1;
	if(%set.sound !$= "")
	{
		if(%set.sound !$= %sound)
		{
			m60_clearDistantSound(%set);
			%set.sound = %sound;
		}
	}
	else
	{
		%set.sound = %sound;
	}
	m60_updateDistantSound(%set);
	return %id;
}
function m60_clearDistantSound(%set)
{
	for(%i=0;%i<%set.demitterCnt;%i++)
	{
		if(isObject(%e = %set.demitter[%i]))
		{
			%e.delete();
			%set.demitter[%i] = "";
		}
	}
	for(%i=0;%i<%set.dclCnt;%i++)
	{
		if((%cl = %set.dcl[%i]) !$= "")
		{
			%set.clSound[%cl] = "";
		}
	}
	%set.dclCnt = %set.demitterCnt = 0;
}
function m60_updateDistantSound(%set)
{
	if(!isObject(%set))
		return;
	if(!isObject(%set.pl))
		return %set.updateSched = schedule(2000,%set,m60_destroyDistantHandle,%set);
		
	cancel(%set.updateSched);
	%set.updateSched = schedule(15000,%set,m60_destroyDistantHandle,%set);
	%pos = %set.pl.getPosition();
	for(%i=0;%i<clientGroup.getCount();%i++)
	{
		%cl = clientGroup.getObject(%i);
		if(!%cl.hasSpawnedOnce)
			continue;
		if(!(%control = %cl.getControlObject()))
			continue;
		%ppos = %control.getPosition();
		%dist = vectorDist(%ppos,%pos);

		if(%set.clSound[%cl])
		{
			if(%dist > %set.range+1)
			{
				%set.clSound[%cl].delete();
				%set.clSound[%cl] = "";
				continue;
			}
			%cnt++;
		}
		else
		{
			if(%dist > %set.range)
				continue;
			%set.clSound[%cl] = %set.demitter[m60_getOpenDistantSoundEmitterIndx(%set,"emitter")] = %emitter =  new AudioEmitter()
			{
				position = vectorAdd(%pos,"0 0 999999999");
				scale = "1 1 1";
				profile = %set.sound;
				useProfileDescription = false;
				description = (%set.isLoop ? AudioLooping2D : Audio2D);
				type = 0;
				volume = 1;
				outsideAmbient = 1;
				referenceDistance = 500;
				maxDistance = 5000;
				isLooping = true;
				loopCount = -1;
			};
			missionCleanup.add(%emitter);
			%set.dcl[m60_getOpenDistantSoundEmitterIndx(%set,"cl")] = %cl;
			%emitter.scopeToClient(%cl);
			%cnt++;
		}
	}
}