datablock ProjectileData(leverRifleProjectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 50;
	headShotDamage 			= 150;
	explosion 				= revolverExplosion;
	directDamageType    	= $DamageType::LeverRifle;
	headShotDamageType		= $DamageType::LeverRifleHeadshot;
	radiusDamageType    	= $DamageType::LeverRifle;
	particleEmitter     	= sWepPenBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	sProjectile = 1;
	sRicochetProj = 1;
	sDamageFalloff = 1;
	sDamageFalloffRatio = 0.06;
};
datablock AudioProfile(leverRifleLoadSound)
{
	filename    = "./sound/rifle_load.wav";
	description = AudioClose3d;
	preload = true;
};	
datablock AudioProfile(leverRifleFireSound)
{
	filename    = "./sound/rifle_fire_v2.wav";
	description = AudioDefault3d;
	preload = true;
};	
datablock AudioProfile(leverRifleBoltOpenSound)
{
	filename    = "./sound/rifle_boltOpen.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(leverRifleBoltCloseSound)
{
	filename    = "./sound/rifle_boltClose.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(rifle_bulletDrop1Sound : leverRifleBoltCloseSound)
{
	filename    = "./sound/rifle_bulletDrop1.wav";
	description = AudioClose3D;
};
datablock AudioProfile(rifle_bulletDrop2Sound : rifle_bulletDrop1Sound)
{
	filename    = "./sound/rifle_bulletDrop2.wav";
};
datablock ItemData(leverRifleItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./model/leverRifle_v2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Lever Rifle";
	iconName = "./model/icon/icon_leverRifle";
	fakeIcon = leverRifleIcon;
	doColorShift = true;
	colorShiftColor = "0.57 0.35 0.2 1";
	ammo = 1;
	canPutInSuitcase = 0;
	isLargeWeapon = 1;
	backImage = leverRifleBackImage;

	image = leverRifleImage;
	canDrop = true;
	
	sAmmoType = "357";
	sAmmo = 3;
	sHeat = 15;
};
datablock ShapeBaseImageData(leverRifleImage)
{
	className = "WeaponImage";
	shapeFile = "./model/leverRifle_v2.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 -0.13 0";
	item = leverRifleItem;
	ammo = " ";
	projectile = leverRifleProjectile;
	projectileSpread = 0;
	projectileSpeed = 200;
	projectileType = Projectile;
	
	casing = revolverShellDebris;
	shellExitDir        = "1.14 -0.7 0.2";
	shellExitDir        = "1.2 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = true;
	colorShiftColor = leverRifleItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Release";
	
	stateName[1]					= "Release";
	stateSequence[1]				= "root";
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTriggerUp[1]	= "Idle";
	
	stateName[2]					= "Idle";
	stateTransitionOnNotLoaded[2]	= "StartLoading";
	stateTransitionOnTriggerDown[2]	= "FireCheckA";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Trigger";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Trigger";
	stateSequence[5]				= "trig";
	stateScript[5]					= "onTrigger";
	stateTimeoutValue[5]			= 0.02;
	stateSound[5]					= revolverTrigSound;
	stateTransitionOnTimeout[5] 	= "Fire";
	
	stateName[6]					= "Fire";
	stateScript[6]					= "onFire";
	stateEmitter[6]					= gunFlashEmitter;
	stateEmitterTime[6]				= 0.05;
	stateSequence[6]				= "fire";
	stateEmitterNode[6]				= "muzzlePoint";
	stateTransitionOnTimeout[6]     = "Smoke";
	stateTimeoutValue[6]            = 0.14;
	
	stateName[7] 					= "Smoke";
	stateEmitter[7]					= sWepsGunSmokeEmitter;
	stateEmitterTime[7]				= 0.05;
	stateEmitterNode[7]				= "muzzlePoint";
	stateTimeoutValue[7]            = 0.1;
	stateSequence[6]				= "untrig";
	stateTransitionOnTimeout[7]     = "BoltWait";
	
	stateName[8]					= "Wait";
	stateScript[8]					= "onWait";
	stateTimeoutValue[8]			= 0.22;
	stateTransitionOnTimeout[8]		= "Release";
	
	stateName[9]					= "DryFire";
	stateSequence[9]				= "trig";
	stateScript[9]					= "onDryFire";
	stateTimeoutValue[9]			= 0.05;
	stateSound[9]					= revolverTrigSound;
	stateTransitionOnTimeout[9] 	= "UnDryFire";
	
	stateName[10]					= "BoltOpen";
	stateSequence[10]				= "boltOpen";
	stateTimeoutValue[10]			= 0.2;
	stateScript[10]					= "onBoltOpen";
	stateTransitionOnTimeout[10]	= "Eject";
	
	stateName[18]					= "Eject";
	stateEjectShell[18]				= true;
	stateScript[18]					= "onEject";
	stateSequence[18]				= "eject";
	stateTimeoutValue[18]			= 0.01;
	stateTransitionOnTimeout[18]	= "EjectWait";
	
	stateName[19]					= "EjectWait";
	stateTimeoutValue[19]			= 0.4;
	stateTransitionOnTimeout[18]	= "BoltClose";
	
	stateName[11]					= "BoltClose";
	stateSequence[11]				= "boltClose";
	stateScript[11]					= "onBoltClose";
	stateTimeoutValue[11]			= 0.2;
	stateTransitionOnTimeout[11]	= "Wait";
	
	stateName[12]					= "LoadCheckA";
	stateScript[12]					= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]	= "LoadA";
	
	stateName[13]					= "LoadCheckB";
	stateTransitionOnLoaded[13]		= "StopLoading";
	stateTransitionOnNotLoaded[13]	= "LoadCheckA";
	
	stateName[14]					= "LoadA";
	stateScript[14]					= "onLoad";
	stateTimeoutValue[14]			= 0.15;
	stateSequence[14]				= "load";
	stateTransitionOnTimeout[14]	= "LoadB";
	
	stateName[15]					= "LoadB";
	stateTimeoutValue[15]			= 0.1;
	stateTransitionOnTimeout[15]	= "LoadC";
	
	stateName[16]					= "LoadC";
	stateTransitionOnTriggerDown[16]= "StopLoading";
	stateTimeoutValue[16]			= 0.12;
	stateTransitionOnTimeout[16]	= "LoadCheckB";
	
	stateName[17]					= "UnDryFire";
	stateSequence[17]				= "undrytrig";
	stateTimeoutValue[17]			= 0.12;
	stateTransitionOnTimeout[17]	= "Wait";
	
	stateName[19]					= "StartLoading";
	stateTimeoutValue[19]			= 0.01;
	stateScript[19]					= "onStartLoading";
	stateTransitionOnTimeout[19]	= "LoadCheckA";
	
	stateName[20]					= "StopLoading";
	stateTimeoutValue[20]			= 0.01;
	stateScript[20]					= "onStopLoading";
	stateTransitionOnTimeout[20]	= "Release";
	
	stateName[21]					= "BoltWait";
	stateTimeoutValue[21]			= 0.2;
	stateTransitionOnTimeout[21]	= "BoltOpen";
};
function leverRifleImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function leverRifleImage::onStartLoading(%db,%pl,%slot)
{
	%pl.setImageLoaded(%slot,0);
}
function leverRifleImage::onStopLoading(%db,%pl,%slot)
{
	%pl.setImageLoaded(%slot,1);
}
function leverRifleImage::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	%pl.playThread(2,plant);
	serverPlay3D(leverRifleFireSound,%pl.getPosition());
	sWeps_fire(%db,%pl,%slot);
	%val = sAmmo_dec(%db,%pl,%slot);
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
		
	%pl.sWeps_fireDelay[%db] = getSimTIme()+1050;
}
function leverRifleImage::onBoltOpen(%db,%pl,%slot)
{
	%pl.schedule(60,playThread,2,plant);
	serverPlay3D(leverRifleBoltOpenSound,%pl.getPosition());
}
function leverRifleImage::onEject(%db,%pl,%slot)
{
	schedule(getRandom(200,300),0,serverPlay3D,rifle_bulletDrop @ getRandom(1,2) @ Sound,%pl.getPosition());
}
function leverRifleImage::onBoltClose(%db,%pl,%slot)
{
	serverPlay3D(leverRifleBoltCloseSound,%pl.getPosition());
}
function leverRifleImage::onDryFire(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	sWeps_displayNotif(%pl,"warn");
}
function leverRifleImage::onLoad(%db,%pl,%slot)
{
	serverPlay3D(leverRifleLoadSound,%pl.getPosition());
	%pl.playThread(2,shiftRight);
	if(sAmmo_rCheck(%db,%pl,%slot) > 0 && sAmmo_check(%db,%pl,%slot) < %db.item.sAmmo)
	{
		sAmmo_rDec(%db,%pl,%slot);
		sAmmo_load(%db,%pl,%slot,sAmmo_check(%db,%pl,%slot)+1);
	}
}
function leverRifleImage::onLoadCheck(%db,%pl,%slot)
{
	if(sAmmo_check(%db,%pl,%slot) < %db.item.sAmmo-1)
	{
		if(($Pref::Swol_ReserveAmmo == 1 && sAmmo_rCheck(%db,%pl,%slot) <= 1))
		{
			%pl.setImageLoaded(%slot,1);
		}
		else
		{
			%pl.setImageLoaded(%slot,0);
		}
	}
	else
	{
		%pl.setImageLoaded(%slot,1);
	}
}