datablock explosionData(m60Explosion : gunExplosion)
{
	soundProfile = "";
	particleEmitter = "";
	subExplosion[0] = sWepsDustSmallExplosion;
};
datablock ProjectileData(m60Projectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 40;
	explosion 				= m60Explosion;
	directDamageType    	= $DamageType::M60;
	radiusDamageType    	= $DamageType::M60;
	particleEmitter     	= sWepPenBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	sProjectile = 1;
	sDamageFalloff = 0.6;
	sDamageFalloffRatio = 0.15;
};
datablock DebrisData(shellHeavyDebris)
{
	shapeFile = "./model/shell_heavy.dts";
	lifetime = 6.0;
	lifetimeVariance = 1.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock DebrisData(m60ClipDebris)
{
	shapeFile = "./model/mag_m60.dts";
	lifetime = 8.0;
	lifetimeVariance = 1.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock ExplosionData(m60ClipExplosion)
{
	debris 					= m60ClipDebris;
	debrisNum 				= 1;
	debrisNumVariance 		= 0;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 1;
	debrisVelocityVariance 	= 0;
};
datablock ProjectileData(m60ClipProjectile)
{
	explosion = m60ClipExplosion;
};
if($Pref::Swol_CreateFakeIcons)
{
	datablock ItemData(m60Icon)
	{
		uiName = "LMG";
		iconName = "./model/icon/icon_m60";
	};
}
datablock AudioProfile(m60FireLoopEndSound)
{
	filename    = "./sound/m60_fireLoopEnd.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(m60FireLoopSound : m60FireLoopEndSound)
{
	filename    = "./sound/m60_fireLoop_v2.wav";
	description = AudioDefaultLooping3D;
};
datablock AudioProfile(m60DistantLoopSound : m60FireLoopEndSound)
{
	filename    = "./sound/m60_distantLoop.wav";
	description = AudioLooping2d;
};
datablock AudioProfile(m60DistantLoopEndSound : m60FireLoopEndSound)
{
	filename    = "./sound/m60_distantLoopEnd.wav";
	description = Audio2d;
};
datablock AudioProfile(m60OpenSound : m60FireLoopEndSound)
{
	filename    = "./sound/m60_open.wav";
};
datablock AudioProfile(m60CloseSound : m60FireLoopEndSound)
{
	filename    = "./sound/m60_close.wav";
};
datablock AudioProfile(m60LoadSound : m60FireLoopEndSound)
{
	filename    = "./sound/m60_load.wav";
};
datablock AudioProfile(m60UnLoadSound : m60FireLoopEndSound)
{
	filename    = "./sound/m60_unload.wav";
};
datablock AudioProfile(heavy_bulletDrop1Sound : m60FireLoopEndSound)
{
	filename    = "./sound/heavy_bulletDrop1.wav";
	description = AudioClose3D;
};
datablock AudioProfile(heavy_bulletDrop2Sound : heavy_bulletDrop1Sound)
{
	filename    = "./sound/heavy_bulletDrop2.wav";
};
datablock AudioProfile(heavy_bulletDrop3Sound : heavy_bulletDrop1Sound)
{
	filename    = "./sound/heavy_bulletDrop3.wav";
};
datablock AudioProfile(heavy_bulletDrop4Sound : heavy_bulletDrop1Sound)
{
	filename    = "./sound/heavy_bulletDrop4.wav";
};
datablock ItemData(m60Item)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./model/m60.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "LMG";
	iconName = "./model/icon/icon_m60";
	fakeIcon = "";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1";
	ammo = 1;
	canPutInSuitcase = 0;
	isLargeWeapon = 1;
	backImage = m60BackImage;

	image = m60Image;
	canDrop = true;
	
	sAmmoType = "heavy";
	sAmmo = 75;
	sHeat = 25;
};
datablock ShapeBaseImageData(m60FakeUnloadA)
{
	shapeFile = "base/data/shapes/empty.dts";
	mountPoint = 0;
	offset = "-0.1	0.18 0.35";
	
	casing = shellHeavyDebris;
	shellExitDir        = "-0.3 -0.1 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 7.0;	
	shellVelocity       = 4.0;
	
	stateName[0]					= "Ready";
	stateTimeoutValue[0]			= 0.01;
	stateTransitionOnTimeout[0] 	= "EjectA";
	
	stateName[1]					= "EjectA";
	stateEjectShell[1]				= true;
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTimeout[1] 	= "EjectB";
	
	stateName[2]					= "EjectB";
	stateEjectShell[2]				= true;
};
datablock ShapeBaseImageData(m60FakeUnloadB)
{
	shapeFile = "base/data/shapes/empty.dts";
	mountPoint = 0;
	offset = "-0.25 0.18 0.35";
	
	casing = shellHeavyDebris;
	shellExitDir        = "-0.6 -0.1 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 7.0;	
	shellVelocity       = 4.0;
	
	stateName[0]					= "Ready";
	stateTimeoutValue[0]			= 0.01;
	stateTransitionOnTimeout[0] 	= "EjectA";
	
	stateName[1]					= "EjectA";
	stateEjectShell[1]				= true;
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTimeout[1] 	= "EjectB";
	
	stateName[2]					= "EjectB";
	stateEjectShell[2]				= true;
};
datablock ShapeBaseImageData(m60FakeEject)
{
	shapeFile = "base/data/shapes/empty.dts";
	mountPoint = 0;
	offset = "-0.25 0.18 0.35";
	
	casing = m60ClipDebris;
	shellExitDir        = "-0.6 -0.1 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 7.0;	
	shellVelocity       = 4.0;
	
	stateName[0]					= "Ready";
	stateTimeoutValue[0]			= 0.01;
	stateTransitionOnTimeout[0] 	= "EjectA";
	
	stateName[1]					= "EjectA";
	stateEjectShell[1]				= true;
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTimeout[1] 	= "Done";
	
	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};
function m60FakeEject::onDone(%db,%pl,%slot)
{
	%pl.unMountImage(%slot);
}
datablock ShapeBaseImageData(m60Image)
{
	className = "WeaponImage";
	shapeFile = "./model/m60.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0.02 0.02";
	eyeOffset = 0;
	item = m60Item;
	ammo = " ";
	projectile = m60Projectile;
	projectileHeatSpread = 0.1;
	projectileSpread = 0.01;
	projectileSpeed = 180;
	projectileType = Projectile;
	
	casing = shellHeavyDebris;
	shellExitDir        = "1.14 -0.7 0.2";
	shellExitDir        = "1.2 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	doColorShift = true;
	colorShiftColor = m60Item.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Idle";
	
	stateName[1]					= "Idle";
	stateTransitionOnTriggerDown[1]	= "Trigger";
	stateTransitionOnNotLoaded[1]	= "Break";
	
	stateName[2]					= "Trigger";
	stateScript[2]					= "onTrigger";
	stateTimeoutValue[2]			= 0.02;
	stateSound[2]					= mac10TrigSound;
	stateSequence[2]				= "trig";
	stateTransitionOnTimeout[2]		= "FireCheckA";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Fire";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Fire";
	stateScript[5]					= "onFire";
	stateSequence[5]				= "fire";
	stateEmitter[5]					= gunFlashEmitter;
	stateEmitterTime[5]				= 0.06;
	stateFire[5]					= true;
	stateEjectShell[5]				= true;
	stateEmitterNode[5]				= "muzzlePoint";
	stateTransitionOnTimeout[5]     = "Check";
	stateTimeoutValue[5]            = 0.07;
	
	stateName[6]					= "Check";
	stateTransitionOnTriggerDown[6]	= "FireCheckA";
	stateTransitionOnTimeout[6]		= "Release";
	
	stateName[7]					= "Release";
	stateScript[7]					= "onRelease";
	stateSequence[7]				= "untrig";
	stateTimeoutValue[7]			= 0.05;
	stateTransitionOnTimeout[7]	= "Wait";
	
	stateName[8]					= "Wait";
	stateTimeoutValue[8]			= 0.05;
	stateTransitionOnTimeout[8]	= "Idle";
	
	stateName[9]					= "DryFire";
	stateScript[9]					= "onDryFire";
	stateTransitionOnTriggerUp[9]	= "Release";
	
	stateName[10]					= "Break";
	stateSequence[10]				= "open";
	stateTimeoutValue[10]			= 0.3;
	stateScript[10]					= "onOpen";
	stateTransitionOnTimeout[10]	= "UnloadA";
	
	stateName[11]					= "UnloadA";
	stateTimeoutValue[11]			= 0.9;
	stateTransitionOnTimeout[11]	= "UnloadB";
	
	stateName[12]					= "UnloadB";
	stateSequence[12]				= "unload";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]					= "onUnload";
	stateTransitionOnTimeout[12]	= "UnloadC";
	
	stateName[13]					= "UnloadC";
	stateTimeoutValue[13]			= 1.8;
	stateTransitionOnTimeout[13]	= "ReloadA";
	
	stateName[14]					= "ReloadA";
	stateSequence[14]				= "load";
	stateTimeoutValue[14]			= 0.01;
	stateScript[14]					= "onReload";
	stateTransitionOnTimeout[14]	= "ReloadB";
	
	stateName[15]					= "ReloadB";
	stateTimeoutValue[15]			= 0.5;
	stateTransitionOnTimeout[15]	= "Unbreak";
	
	stateName[16]					= "Unbreak";
	stateSequence[16]				= "close";
	stateTimeoutValue[16]			= 0.3;
	stateScript[16]					= "onClose";
	stateTransitionOnTimeout[16]	= "Idle";
};
function m60Image::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function m60Image::onFireAnimCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,%pl.m60AnimFrame);
	%pl.m60AnimFrame = !%pl.m60AnimFrame;
}
function m60Image::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	%pl.playThread(2,plant);
	
	if(isFunction("m60_iniDistantSound"))
		m60_iniDistantSound(%pl.m60_distantHandle,m60DistantLoopSound,%pl,160,1);

	sWeps_loopingAudioStart(%db,%pl,%slot,m60FireLoopSound);
	sWeps_fire(%db,%pl,%slot);
	
	%val = sAmmo_dec(%db,%pl,%slot);
	if(!sAmmo_check(%db,%pl,%slot))
		serverPlay3D(mac10LastRoundSound,%pl.getPosition());
		
	if(getSimTime()-%pl.lastShellSound > 400 || !getRandom(0,1))
	{
		%pl.lastShellSound = getSimTime();
		schedule(getRandom(250,350),0,serverPlay3D,heavy_bulletDrop @ getRandom(1,4) @ Sound,%pl.getPosition());
	}
	if(%val == 0)
		%pl.setImageAmmo(%slot,%pl.m60AnimFrame);
}
function m60Image::onUnload(%db,%pl,%slot)
{
	sWeps_display(%pl,0);
	%up = %pl.getUpVectorHack();
	%forward = %pl.getEyeVectorHack();

	%val = sAmmo_check(%db,%pl,%slot);
	%max = %val/30;
	if(%max < 1)
		%max = 1;
	for(%i=0;%i<%max;%i++)
	{
		%a = new aiPlayer()
		{
			datablock = emptyPlayer;
			position = %pl.getPosition();
			scale = "1 1 1";
		};
		%a.setDamageLevel(100);
		%a.setTransform(%pl.getSlotTransform(0));
		if(%i == 0)
		{
			%a.mountImage(m60FakeUnloadA,0);
			%a.mountImage(m60FakeUnloadA,1);
			%a.mountImage(m60FakeUnloadA,2);
		}
		else
		{
			%a.mountImage(m60FakeUnloadB,0);
			%a.mountImage(m60FakeUnloadB,1);
			%a.mountImage(m60FakeUnloadB,2);
		}
		%a.schedule(80,delete);
	}
	%pl.mountImage(m60FakeEject,1);
	%pl.schedule(560,unMountImage,1);
	%pl.playThread(2,shiftLeft);
	serverPlay3D(m60UnloadSound,%pl.getPosition());
	
	for(%i=0;%i<2+(mClamp(%max,0,6));%i++)
		schedule(getRandom(250,350),0,serverPlay3D,heavy_bulletDrop @ getRandom(1,4) @ Sound,%pl.getPosition());
}
function m60Image::onReload(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	sAmmo_reload(%db,%pl,%slot);
	%pl.sWeps_fireDelay[%db] = getSimTIme()+800;
	serverPlay3D(m60LoadSound,%pl.getPosition());
}
function m60Image::onOpen(%db,%pl,%slot)
{
	serverPlay3D(m60OpenSound,%pl.getPosition());
}
function m60Image::onClose(%db,%pl,%slot)
{
	//%pl.playThread(2,shiftLeft);
	%pl.setImageLoaded(%slot,1);
	serverPlay3D(m60CloseSound,%pl.getPosition());
}
function m60Image::onRelease(%db,%pl,%slot)
{
	if(sWeps_loopingAudioEnd(%db,%pl,%slot,m60FireLoopEndSound))
		if(isFunction("m60_iniDistantSound"))
			m60_iniDistantSound(%pl.m60_distantHandle,m60DistantLoopEndSound,%pl,160,0);
}
function m60Image::onDryFire(%db,%pl,%slot)
{
	if(sWeps_loopingAudioEnd(%db,%pl,%slot,m60FireLoopEndSound))
		if(isFunction("m60_iniDistantSound"))
			m60_iniDistantSound(%pl.m60_distantHandle,m60DistantLoopEndSound,%pl,160,0);

	sWeps_displayNotif(%pl,"warn");
	serverPlay3D(ar15DryFireSound,%pl.getPosition());
}
function m60Image::onUnMount(%db,%pl,%slot)
{
	if(sWeps_loopingAudioEnd(%db,%pl,%slot,m60FireLoopEndSound))
		if(isFunction("m60_iniDistantSound"))
			m60_iniDistantSound(%pl.m60_distantHandle,m60DistantLoopEndSound,%pl,160,0);
	parent::onUnMount(%db,%pl,%slot);
}