datablock explosionData(mac10Explosion : gunExplosion)
{
	soundProfile = "";
	particleEmitter = "";
	subExplosion[0] = sWepsDustSmallExplosion;
};
datablock ProjectileData(mac10Projectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 13;
	explosion 				= mac10Explosion;
	directDamageType    	= $DamageType::Mac10;
	radiusDamageType    	= $DamageType::Mac10;
	particleEmitter     	= sWepBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 50;
	impactImpulse 			= 250;
	sProjectile = 1;
	sDamageFalloff = 0.6;
	sDamageFalloffRatio = 0.5;
};
datablock AudioProfile(mac10FireLoopEndSound)
{
	filename    = "./sound/mac10_fireLoopEnd.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(mac10FireLoopSound : mac10FireLoopEndSound)
{
	filename    = "./sound/mac10_fireLoop.wav";
	description = AudioDefaultLooping3D;
};
datablock AudioProfile(mac10DryFireSound : mac10FireLoopEndSound)
{
	filename    = "./sound/mac10_dryfire.wav";
};
datablock AudioProfile(mac10LastRoundSound : mac10FireLoopEndSound)
{
	filename    = "./sound/mac10_lastround.wav";
};
datablock AudioProfile(mac10TrigSound : mac10FireLoopEndSound)
{
	filename    = "./sound/mac10_trig.wav";
	description = AudioClose3d;
};
datablock AudioProfile(mac10LoadSound : mac10FireLoopEndSound)
{
	filename    = "./sound/mac10_load.wav";
};
datablock AudioProfile(mac10UnloadSound : mac10FireLoopEndSound)
{
	filename    = "./sound/mac10_unload.wav";
};
datablock AudioProfile(small_bulletDrop1Sound : mac10FireLoopEndSound)
{
	filename    = "./sound/small_bulletDrop1.wav";
	description = AudioClose3D;
};
datablock AudioProfile(small_bulletDrop2Sound : mac10FireLoopEndSound)
{
	filename    = "./sound/small_bulletDrop2.wav";
	description = AudioClose3D;
};
datablock AudioProfile(small_bulletDrop3Sound : mac10FireLoopEndSound)
{
	filename    = "./sound/small_bulletDrop3.wav";
	description = AudioClose3D;
};
datablock AudioProfile(small_bulletDrop4Sound : mac10FireLoopEndSound)
{
	filename    = "./sound/small_bulletDrop4.wav";
	description = AudioClose3D;
};
datablock AudioProfile(small_bulletDrop5Sound : mac10FireLoopEndSound)
{
	filename    = "./sound/small_bulletDrop5.wav";
	description = AudioClose3D;
};
datablock DebrisData(shell9mmDebris)
{
	shapeFile = "./model/shell_9mm.dts";
	lifetime = 6.0;
	lifetimeVariance = 1.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock DebrisData(mac10ClipDebris)
{
	shapeFile = "./model/mag_mac10.dts";
	lifetime = 8.0;
	lifetimeVariance = 1.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock ExplosionData(mac10ClipExplosion)
{
	debris 					= mac10ClipDebris;
	debrisNum 				= 1;
	debrisNumVariance 		= 0;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 1;
	debrisVelocityVariance 	= 0;
};
datablock ProjectileData(mac10ClipProjectile)
{
	explosion = mac10ClipExplosion;
};
if($Pref::Swol_CreateFakeIcons)
{
	datablock ItemData(mac10Icon)
	{
		uiName = "SMG";
		iconName = "./model/icon/icon_mac10";
	};
}
datablock ItemData(mac10Item)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "secondary";

	shapeFile = "./model/mac10.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "SMG";
	iconName = "./model/icon/icon_mac10";
	fakeIcon = mac10Icon;
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1";
	ammo = 1;

	image = mac10Image;
	canDrop = true;
	
	sAmmoType = "9mm";
	sAmmo = 32;
	sHeat = 25;
};
datablock ShapeBaseImageData(mac10Image)
{
	className = "WeaponImage";
	shapeFile = "./model/mac10.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0.06 0";
	item = mac10Item;
	ammo = " ";
	projectile = mac10Projectile;
	projectileHeatSpread = 0.035;
	projectileSpread = 0.015;
	projectileSpeed = 180;
	projectileType = Projectile;
	
	casing = shell9mmDebris;
	shellExitDir        = "0.8 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = true;
	colorShiftColor = mac10Item.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Idle";
	
	stateName[1]					= "Idle";
	stateTransitionOnNotLoaded[1]	= "UnloadA";
	stateTransitionOnTriggerDown[1]	= "Trigger";
	
	stateName[2]					= "Trigger";
	stateScript[2]					= "onTrigger";
	stateTimeoutValue[2]			= 0.02;
	stateSound[2]					= mac10TrigSound;
	stateSequence[2]				= "trig";
	stateTransitionOnTimeout[2]		= "FireCheckA";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Fire";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Fire";
	stateScript[5]					= "onFire";
	stateEmitter[5]					= gunFlashEmitter;
	stateEmitterTime[5]				= 0.05;
	stateFire[5]					= true;
	stateEjectShell[5]				= true;
	stateSequence[5]				= "fire";
	stateEmitterNode[5]				= "muzzlePoint";
	stateTransitionOnTimeout[5]     = "Check";
	stateTimeoutValue[5]            = 0.05;
	
	stateName[6]					= "Check";
	stateTransitionOnTriggerDown[6] = "FireCheckA";
	stateTransitionOnTimeout[6]		= "Release";
	
	stateName[7]					= "Release";
	stateScript[7]					= "onRelease";
	stateSequence[7]				= "untrig";
	stateTimeoutValue[7]			= 0.05;
	stateTransitionOnTimeout[7]		= "Wait";
	
	stateName[8]					= "Wait";
	stateTimeoutValue[8]			= 0.05;
	stateTransitionOnTimeout[8]		= "Idle";
	
	stateName[9]					= "UnloadA";
	stateSequence[9]				= "unload";
	stateTimeoutValue[9]			= 0.01;
	stateScript[9]					= "onUnload";
	stateTransitionOnTimeout[9]		= "UnloadB";
	
	stateName[10]					= "UnloadB";
	stateTimeoutValue[10]			= 0.7;
	stateTransitionOnTimeout[10]	= "ReloadA";
	
	stateName[11]					= "ReloadA";
	stateSequence[11]				= "reload";
	stateTimeoutValue[11]			= 0.01;
	stateScript[11]					= "onReloadA";
	stateTransitionOnTimeout[11]	= "ReloadB";
	
	stateName[12]					= "ReloadB";
	stateTimeoutValue[12]			= 0.25;
	stateTransitionOnTimeout[12]	= "ReloadC";
	
	stateName[13]					= "ReloadC";
	stateScript[13]					= "onReloadB";
	stateSequence[13]				= "fire";
	stateTimeoutValue[13]			= 0.2;
	stateTransitionOnTimeout[13]	= "Idle";
	
	stateName[14]					= "DryFire";
	stateScript[14]					= "onDryFire";
	stateTransitionOnTriggerUp[14]	= "Release";
};
function mac10Image::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function mac10Image::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	%pl.playThread(2,shiftLeft);
	%pl.playThread(3,shiftRight);
	sWeps_loopingAudioStart(%db,%pl,%slot,mac10FireLoopSound);
	sWeps_fire(%db,%pl,%slot);
	
	%val = sAmmo_dec(%db,%pl,%slot);
	if(!sAmmo_check(%db,%pl,%slot))
		serverPlay3D(mac10LastRoundSound,%pl.getPosition());
		
	if(getSimTime()-%pl.lastShellSound > 400 || getRandom(0,1) == 0)
	{
		%pl.lastShellSound = getSimTime();
		schedule(getRandom(200,300),0,serverPlay3D,small_bulletDrop @ getRandom(1,5) @ Sound,%pl.getPosition());
	}
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
}
function mac10Image::onUnload(%db,%pl,%slot)
{
	sWeps_display(%pl,0);
	%up = %pl.getUpVectorHack();
	%forward = %pl.getEyeVectorHack();
	
	%p = new projectile()
	{
		datablock = mac10ClipProjectile;
		initialPosition = vectorAdd(%pl.getSlotTransform(%slot),vectorRelativeShift(%forward,%up,"-0.1 0 -0.7"));
	};
	%p.explode();
	%pl.playThread(2,shiftTo);
	serverPlay3D(mac10UnLoadSound,%pl.getPosition());
}
function mac10Image::onReloadA(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	serverPlay3D(mac10LoadSound,%pl.getPosition());
}
function mac10Image::onReloadB(%db,%pl,%slot)
{
	%pl.playThread(2,shiftLeft);
	%pl.setImageLoaded(%slot,1);
	sAmmo_reload(%db,%pl,%slot);
}
function mac10Image::onRelease(%db,%pl,%slot)
{
	sWeps_loopingAudioEnd(%db,%pl,%slot,mac10FireLoopEndSound);
}
function mac10Image::onDryFire(%db,%pl,%slot)
{
	sWeps_loopingAudioEnd(%db,%pl,%slot,mac10FireLoopEndSound);
	sWeps_displayNotif(%pl,"warn");
	serverPlay3D(mac10DryFireSound,%pl.getPosition());
}
function mac10Image::onUnMount(%db,%pl,%slot)
{
	sWeps_loopingAudioEnd(%db,%pl,%slot,mac10FireLoopEndSound);
	parent::onUnMount(%db,%pl,%slot);
}