datablock explosionData(pistolExplosion : gunExplosion)
{
	soundProfile = "";
	particleEmitter = "";
	subExplosion[0] = sWepsDustSmallExplosion;
};
datablock ProjectileData(pistolProjectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 25;
	explosion 				= pistolExplosion;
	directDamageType    	= $DamageType::Pistol;
	radiusDamageType    	= $DamageType::Pistol;
	particleEmitter     	= sWepBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	sProjectile = 1;
	sDamageFalloff = 0.8;
	sDamageFalloffRatio = 0.6;
};
datablock AudioProfile(pistolFire1Sound)
{
	filename    = "./sound/pistol_fire1.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(pistolFire2Sound : pistolFire1Sound)
{
	filename    = "./sound/pistol_fire2.wav";
	description = AudioDefault3d;
};
datablock AudioProfile(pistolFire3Sound : pistolFire1Sound)
{
	filename    = "./sound/pistol_fire3.wav";
	description = AudioDefault3d;
};
datablock AudioProfile(pistolUnloadSound : pistolFire1Sound)
{
	filename    = "./sound/pistol_unload.wav";
	description = AudioClosest3d;
};
datablock AudioProfile(pistolLoadSound : pistolFire1Sound)
{
	filename    = "./sound/pistol_load.wav";
	description = AudioClosest3d;
};
datablock AudioProfile(pistolSpinSound : pistolFire1Sound)
{
	filename    = "./sound/pistol_spin.wav";
	description = AudioClose3d;
	preload = true;
};

datablock DebrisData(pistolClipDebris)
{
	shapeFile = "./model/mag_pistol_v2.dts";
	lifetime = 8.0;
	lifetimeVariance = 1.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock ExplosionData(pistolClipExplosion)
{
	debris 					= pistolClipDebris;
	debrisNum 				= 1;
	debrisNumVariance 		= 0;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 1;
	debrisVelocityVariance 	= 0;
};
datablock ProjectileData(pistolClipProjectile)
{
	explosion = pistolClipExplosion;
};
if($Pref::Swol_CreateFakeIcons)
{
	datablock ItemData(pistolIcon)
	{
		uiName = "Pistol";
		iconName = "./model/icon/icon_pistol";
	};
}
datablock ItemData(pistolItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "secondary";

	shapeFile = "./model/pistol_v2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Pistol";
	iconName = "./model/icon/icon_pistol";
	fakeIcon = pistolIcon;
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1";
	ammo = 1;
	canPutInSuitcase = 1;

	image = pistolImage;
	canDrop = true;
	
	sAmmoType = "9mm";
	sAmmo = 12;
	sHeat = 15;
};
datablock ShapeBaseImageData(pistolImage)
{
	className = "WeaponImage";
	shapeFile = "./model/pistol_v2.dts";
	emap = true;
	mountPoint = 0;
	offset = "-0.014 0.05 -0.02";
	item = pistolItem;
	ammo = " ";
	projectile = pistolProjectile;
	projectileSpread = 0.005;
	projectileHeatSpread = 0.035;
	projectileSpeed = 180;
	projectileType = Projectile;
	
	casing = shell9mmDebris;
	shellExitDir        = "1.14 -0.7 0.2";
	shellExitDir        = "1.2 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = true;
	colorShiftColor = pistolItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Idle";
	
	stateName[1]					= "Idle";
	stateTransitionOnNotLoaded[1]	= "UnloadA";
	stateTransitionOnTriggerDown[1]	= "Trigger";
	
	stateName[2]					= "Trigger";
	stateScript[2]					= "onTrigger";
	stateTimeoutValue[2]			= 0.02;
	stateSound[2]					= mac10TrigSound;
	stateSequence[2]				= "trig";
	stateTransitionOnTimeout[2]		= "FireCheckA";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Fire";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Fire";
	stateScript[5]					= "onFire";
	stateEmitter[5]					= gunFlashEmitter;
	stateEmitterTime[5]				= 0.05;
	stateFire[5]					= true;
	stateEjectShell[5]				= true;
	stateSequence[5]				= "fire";
	stateEmitterNode[5]				= "muzzlePoint";
	stateTransitionOnTimeout[5]     = "Release";
	stateTimeoutValue[5]            = 0.12;
	
	stateName[6]					= "Release";
	stateScript[6]					= "onRelease";
	stateTransitionOnTriggerUp[6]	= "Wait";
	
	stateName[7]					= "Wait";
	stateTimeoutValue[7]			= 0.07;
	stateTransitionOnTimeout[7]		= "Idle";
	
	stateName[8]					= "UnloadA";
	stateSequence[8]				= "unload";
	stateTimeoutValue[8]			= 0.01;
	stateScript[8]					= "onUnload";
	stateTransitionOnTimeout[8]		= "UnloadB";
	
	stateName[9]					= "UnloadB";
	stateScript[9]					= "onReloadAnimCheck";
	stateTimeoutValue[9]			= 0.7;
	stateTransitionOnTimeout[9]		= "ReloadAnimCheck";
	
	stateName[10]					= "ReloadAnimCheck";
	stateTransitionOnAmmo[10]		= "ReloadA";
	stateTransitionOnNoAmmo[10]		= "ReloadA_Special";
	
	stateName[11]					= "ReloadA";
	stateSequence[11]				= "reload";
	stateTimeoutValue[11]			= 0.01;
	stateScript[11]					= "onReloadA";
	stateTransitionOnTimeout[11]	= "ReloadB";
	
	stateName[12]					= "ReloadB";
	stateTimeoutValue[12]			= 0.25;
	stateTransitionOnTimeout[12]	= "ReloadC";
	
	stateName[13]					= "ReloadC";
	stateScript[13]					= "onReloadB";
	stateTimeoutValue[13]			= 0.1;
	stateTransitionOnTimeout[13]	= "Idle";
	
	stateName[14]					= "DryFire";
	stateSequence[14]				= "dryfire";
	stateScript[14]					= "onDryFire";
	stateTransitionOnTimeout[14]	= "Release";
	stateTimeoutValue[14]			= 0.12;
	
	stateName[15]					= "ReloadA_Special";
	stateSequence[15]				= "reloadTrick";
	stateTimeoutValue[15]			= 0.25;
	stateSound[15]					= pistolSpinSound;
	stateTransitionOnTimeout[15]	= "ReloadB_Special";
	
	
	stateName[16]					= "ReloadB_Special";
	stateScript[16]					= "onReloadSpecial";
	stateTimeoutValue[16]			= 0.1;
	stateTransitionOnTimeout[16]	= "Idle";
};
function pistolImage::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	%pl.playThread(2,plant);
	serverPlay3D(pistolFire @ getRandom(1,3) @ Sound,%pl.getPosition());
	
	sWeps_fire(%db,%pl,%slot);
	
	%val = sAmmo_dec(%db,%pl,%slot);
	if(!sAmmo_check(%db,%pl,%slot))
		serverPlay3D(mac10LastRoundSound,%pl.getPosition());
		
	if(getSimTime()-%pl.lastShellSound > 400 || getRandom(0,1) == 0)
	{
		%pl.lastShellSound = getSimTime();
		schedule(getRandom(200,300),0,serverPlay3D,small_bulletDrop @ getRandom(1,5) @ Sound,%pl.getPosition());
	}
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
}
function pistolImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function pistolImage::onDryFire(%db,%pl,%slot)
{
	sWeps_displayNotif(%pl,"warn");
}
function pistolImage::onUnload(%db,%pl,%slot)
{
	sWeps_display(%pl,0);
	%up = %pl.getUpVectorHack();
	%forward = %pl.getEyeVectorHack();
	
	%p = new projectile()
	{
		datablock = pistolClipProjectile;
		initialPosition = vectorAdd(%pl.getSlotTransform(%slot),vectorRelativeShift(%forward,%up,"-0.2 0 -0.7"));
	};
	%p.explode();
	%pl.playThread(2,shiftTo);
	serverPlay3D(pistolUnloadSound,%pl.getPosition());
}
function pistolImage::onReloadA(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	schedule(20,0,serverPlay3D,pistolLoadSound,%pl.getPosition());
}
function pistolImage::onReloadB(%db,%pl,%slot)
{
	//%pl.playThread(2,shiftLeft);
	%pl.setImageLoaded(%slot,1);
	sAmmo_reload(%db,%pl,%slot);
}
function pistolImage::onReloadAnimCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,getRandom(0,3));
}
function pistolImage::onReloadSpecial(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	schedule(20,0,serverPlay3D,pistolLoadSound,%pl.getPosition());
	
	%pl.setImageLoaded(%slot,1);
	sAmmo_reload(%db,%pl,%slot);
}