datablock explosionData(revolverExplosion : gunExplosion)
{
	soundProfile = "";
	particleEmitter = "";
	subExplosion[0] = sWepsDustExplosion;
};

datablock ProjectileData(revolverProjectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 48;
	headShotDamage 			= 250;
	explosion 				= revolverExplosion;
	directDamageType    	= $DamageType::Revolver;
	headShotDamageType		= $DamageType::RevolverHeadshot;
	radiusDamageType    	= $DamageType::Revolver;
	particleEmitter     	= sWepPenBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	sProjectile = 1;
	sRicochetProj = 1;
	sDamageFalloff = 3;
	sDamageFalloffRatio = 0.04;
};
datablock ProjectileData(sWepRicochetProjectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	explosion 				= mac10Explosion;
	particleEmitter     	= sWepPenBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	isBallistic = 0;
	gravityMod = 0;
	armingDelay = 1;
	directDamage        	= 5;
	headShotDamage 			= 10;
	sProjectile = 1;
	directDamageType    	= $DamageType::Revolver;
	headshotDamageType    	= $DamageType::RevolverHeadshot;
	radiusDamageType    	= $DamageType::Revolver;
};
datablock AudioProfile(revolverFire1Sound)
{
	filename    = "./sound/rev_fire1.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(revolverFire2Sound)
{
	filename    = "./sound/rev_fire2.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(revolverTrickSound : revolverFire1Sound)
{
	filename    = "./sound/rev_trick.wav";
	description = AudioClosest3d;
};
datablock AudioProfile(revolverSpinLoopSound : revolverFire1Sound)
{
	filename    = "./sound/rev_spin_v2.wav";
	description = AudioCloseLooping3d;
};
datablock AudioProfile(revolverSpinStopSound : revolverFire1Sound)
{
	filename    = "./sound/rev_spinStop.wav";
	description = AudioClose3d;
};
datablock AudioProfile(revolverTrigSound : revolverFire1Sound)
{
	filename    = "./sound/rev_trig.wav";
	description = AudioClosest3d;
};
datablock AudioProfile(revolverOpenSound : revolverFire1Sound)
{
	filename    = "./sound/rev_open.wav";
};
datablock AudioProfile(revolverCloseSound : revolverFire1Sound)
{
	filename    = "./sound/rev_close.wav";
};
datablock AudioProfile(revolverCockSound : revolverFire1Sound)
{
	filename    = "./sound/rev_cock.wav";
	description = AudioClosest3d;
};
datablock AudioProfile(revolverLoadSound : revolverFire1Sound)
{
	filename    = "./sound/rev_load.wav";
};
datablock AudioProfile(revolverRicochet1Sound : revolverFire1Sound)
{
	filename    = "./sound/rev_ricochet1.wav";
	description = AudioClosest3d;
};
datablock AudioProfile(revolverRicochet2Sound : revolverRicochet1Sound)
{
	filename    = "./sound/rev_ricochet2.wav";
};
datablock AudioProfile(revolverRicochet3Sound : revolverRicochet1Sound)
{
	filename    = "./sound/rev_ricochet3.wav";
};
datablock AudioProfile(revolverAimToSound : revolverFire1Sound)
{
	filename    = "./sound/rev_to.wav";
	description = AudioClose3d;
};
datablock AudioProfile(revolverAimAwaySound : revolverFire1Sound)
{
	filename    = "./sound/rev_away.wav";
	description = AudioClose3d;
};
datablock AudioProfile(revolverSummonSound : revolverFire1Sound)
{
	filename    = "./sound/godhasleft.wav";
	description = Audio2D;
};
datablock AudioProfile(revolverSUICIDESound : revolverFire1Sound)
{
	filename    = "./sound/dramatic_suicide.wav";
	description = Audio2D;
};
datablock DebrisData(revolverShellDebris)
{
	shapeFile = "./model/shell_357.dts";
	lifetime = 7.0;
	lifetimeVariance = 1.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
if($Pref::Swol_CreateFakeIcons)
{
	datablock ItemData(revolverIcon)
	{
		uiName = "Revolver";
		iconName = "./model/icon/icon_revolver";
	};
}
datablock ItemData(revolverItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "secondary";

	shapeFile = "./model/revolver_item_v3.dts";  //the revolver model is such a nightmare I don't know how to make it work normally
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Revolver";
	iconName = "./model/icon/icon_revolver";
	fakeIcon = revolverIcon;
	doColorShift = false;
	colorShiftColor = "0.57 0.35 0.2 1";
	ammo = 1;

	image = revolverImage;
	altImage[0] = revolverTrickAImage;
	altImageChance[0] = 0.18;
	altImage[1] = revolverTrickBImage;
	altImageChance[1] = 0.02;
	altImageCnt = 2;
	canDrop = true;
	
	sAmmoType = "357";
	sAmmo = 6;
};
datablock ShapeBaseImageData(revolverFakeEject)
{
	shapeFile = "base/data/shapes/empty.dts";
	mountPoint = 0;
	offset = "-0.15 0.34 0.26";
	
	casing = revolverShellDebris;
	shellExitDir        = "-0.1 -0.6 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 7.0;	
	shellVelocity       = 4.0;
	
	stateName[0]					= "Ready";
	stateTimeoutValue[0]			= 0.01;
	stateTransitionOnTimeout[0] 	= "EjectA";
	
	stateName[1]					= "EjectA";
	stateEjectShell[1]				= true;
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTimeout[1] 	= "EjectB";
	
	stateName[2]					= "EjectB";
	stateEjectShell[2]				= true;
};
//schedule(1,0,exec,"Add-Ons/Weapon_SWeps/revolver_trick.cs");
//exec("./revolver_trick.cs");



datablock ShapeBaseImageData(revolverImage)
{
	className = "WeaponImage";
	shapeFile = "./model/revolver_v3.dts";
	emap = true;
	mountPoint = 0;
	offset = (-0.014) SPC -0.2236 SPC (-0.08-0.19197);
	item = revolverItem;
	ammo = " ";
	projectile = revolverProjectile;
	projectileSpread = 0;
	projectileSpeed = 200;
	projectileType = Projectile;
	
	casing = revolverShellDebris;
	shellExitDir        = "0.14 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = false;
	colorShiftColor = revolverItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.36;
	stateTransitionOnTimeout[0] 	= "Release";
	
	stateName[1]					= "Release";
	stateTransitionOnTriggerUp[1]	= "Idle";
	
	stateName[2]					= "Idle";
	stateTransitionOnNotLoaded[2]	= "Reload";
	stateTransitionOnTriggerDown[2]	= "T1";
	
	stateName[3]					= "T1";
	stateScript[3]					= "onTrigPrep";
	stateSequence[3]				= "trig1";
	stateTimeoutValue[3]			= 0.08;
	stateTransitionOnTimeout[3]		= "T2";
	stateTransitionOnTriggerUp[3]	= "WaitRelease";
	
	stateName[4]					= "UT1";
	stateSequence[4]				= "trig1";
	stateTimeoutValue[4]			= 0.02;
	stateDirection[4]				= 0;
	stateScript[4]					= "onUnTrig";
	stateTransitionOnTimeout[4]		= "WaitRelease";
	
	stateName[5]					= "T2";
	stateSequence[5]				= "trig2";
	stateTimeoutValue[5]			= 0.02;
	stateTransitionOnTimeout[5]		= "T3";
	stateTransitionOnTriggerUp[5]	= "UT1";
	
	stateName[6]					= "UT2";
	stateSequence[6]				= "trig2";
	stateTimeoutValue[6]			= 0.02;
	stateTransitionOnTimeout[6]		= "UT1";
	stateDirection[6]				= 0;
	
	stateName[7]					= "T3";
	stateSequence[7]				= "trig3";
	stateTimeoutValue[7]			= 0.02;
	stateTransitionOnTimeout[7]		= "T4";
	stateTransitionOnTriggerUp[7]	= "UT2";
	
	stateName[8]					= "UT3";
	stateSequence[8]				= "trig3";
	stateTimeoutValue[8]			= 0.02;
	stateTransitionOnTimeout[8]		= "UT2";
	stateDirection[8]				= 0;
	
	stateName[9]					= "T4";
	stateSequence[9]				= "trig4";
	stateTimeoutValue[9]			= 0.02;
	stateTransitionOnTimeout[9]		= "T5";
	stateTransitionOnTriggerUp[9]	= "UT3";
	
	stateName[10]					= "UT4";
	stateSequence[10]				= "trig4";
	stateTimeoutValue[10]			= 0.02;
	stateTransitionOnTimeout[10]		= "UT3";
	stateDirection[10]				= 0;
	
	stateName[11]					= "T5";
	stateSequence[11]				= "trig5";
	stateTimeoutValue[11]			= 0.02;
	stateTransitionOnTimeout[11]		= "T6";
	stateTransitionOnTriggerUp[11]	= "UT4";
	
	stateName[12]					= "UT5";
	stateSequence[12]				= "trig5";
	stateTimeoutValue[12]			= 0.02;
	stateTransitionOnTimeout[12]		= "UT4";
	stateDirection[12]				= 0;
	
	stateName[13]					= "T6";
	stateSequence[13]				= "trig6";
	stateTimeoutValue[13]			= 0.02;
	stateTransitionOnTimeout[13]	= "FireCheckB";
	stateScript[13]					= "onFireCheck";
	stateTransitionOnTriggerUp[13]	= "UT5";
		
	stateName[14]					= "FireCheckB";
	stateTransitionOnAmmo[14]		= "FireAnim";
	stateTransitionOnNoAmmo[14]		= "DryFire";
	
	stateName[15]					= "Fire";
	stateTimeoutValue[15]			= 0.1;
	stateEmitter[15]					= gunFlashEmitter;
	stateEmitterTime[15]				= 0.05;
	stateEmitterNode[15]				= "muzzlePoint";
	stateScript[15]					= "onFire";
	stateTransitionOnTimeout[15]		= "Smoke";
	stateFire[15]					= true;
	
	stateName[16]					= "Smoke";
	stateTimeoutValue[16]			= 0.1;
	stateEmitter[16]					= sWepsGunSmokeEmitter;
	stateEmitterTime[16]				= 0.05;
	stateEmitterNode[16]				= "muzzlePoint";
	stateTransitionOnTimeout[16]		= "WaitRelease";
	
	stateName[17]					= "DryFire";
	stateTimeoutValue[17]			= 0.16;
	stateSequence[17]				= "fire";
	stateScript[17]					= "onDryFire";
	stateTransitionOnTimeout[17]	= "WaitRelease";
	
	stateName[18]					= "WaitRelease";
	stateTimeoutValue[18]			= 0.2;
	stateSequence[18]				= "root";
	stateTransitionOnTimeout[18]	= "Release";
	
	stateName[19]					= "FireAnim";
	stateSequence[19]				= "fire";
	stateTimeoutValue[19]			= 0.02;
	stateScript[19]					= "onTrig";
	stateTransitionOnTimeout[19]	= "Fire";
	
	stateName[20]					= "Reload";
	stateScript[20]					= "onReload";
};
function revolverImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function revolverImage::onDryFire(%db,%pl,%slot)
{
	serverPlay3D(revolverTrigSound,%pl.getPosition());
	%pl.playThread(2,plant);
	sWeps_displayNotif(%pl,"warn");
}
function revolverImage::onFire(%db,%pl,%slot)
{
	%pl.client.revTrigSucessCnt++;
	%pl.client.revTrigFailCnt = 0;
	
	%pl.playThread(2,plant);
	serverPlay3D(revolverFire @ getRandom(1,2) @ Sound,%pl.getPosition());
	%p = sWeps_fire(%db,%pl,%slot);
	%val = sAmmo_dec(%db,%pl,%slot);
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
		
	%pl.sWeps_fireDelay[%db] = getSimTime()+450;
}
function revolverImage::onUnTrig(%db,%pl,%slot)
{
	if(isObject(%cl = %pl.client))
	{
		if(%cl.revTrigSucessCnt < 3)
		{
			%cl.revTrigFailCnt++;
			if(%cl.revTrigFailCnt >= 3)
			{
				messageClient(%cl,'',%str = "\c3Click and hold to fire the revolver.");
				centerPrint(%cl,"<br><br><br>" @ %str,3);
				%cl.revTrigFailCnt = -4;
			}
		}
	}
}
function revolverImage::onTrig(%db,%pl,%slot)
{
	serverPlay3D(revolverTrigSound,%pl.getPosition());
}
function revolverImage::onTrigPrep(%db,%pl,%slot)
{
	serverPlay3D(revolverCockSound,%pl.getPosition());
}
function revolverImage::onReload(%db,%pl,%slot)
{
	%pl.mountImage(revolverReloadImage,0);
}
datablock ShapeBaseImageData(revolverReloadImage)
{
	className = "WeaponImage";
	shapeFile = "./model/revolver_v3.dts";
	emap = true;
	mountPoint = 0;
	offset = (-0.014) SPC -0.2236 SPC (-0.08-0.19197);
	item = revolverItem;
	ammo = " ";
	projectile = revolverProjectile;
	projectileType = Projectile;
	
	casing = revolverShellDebris;
	shellExitDir        = "0.14 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = false;
	colorShiftColor = revolverItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.01;
	stateTransitionOnTimeout[0] 	= "UnloadA";
	
	stateName[1]					= "UnloadA";
	stateSequence[1]				= "pop";
	stateScript[1]					= "onUnload";
	stateTimeoutValue[1]			= 0.3;
	stateTransitionOnTimeout[1]		= "UnloadB";
	
	stateName[2]					= "UnloadB";
	stateSequence[2]				= "eject";
	stateScript[2]					= "onEject";
	stateTimeoutValue[2]			= 0.01;
	stateTransitionOnTimeout[2]		= "UnloadC";
	
	stateName[3]					= "UnloadC";
	stateTimeoutValue[3]			= 1.2;
	stateTransitionOnTimeout[3]		= "ReloadA";
	
	stateName[4]					= "ReloadA";
	stateSequence[4]				= "load";
	stateTimeoutValue[4]			= 0.01;
	stateScript[4]					= "onLoad";
	stateTransitionOnTimeout[4]		= "ReloadB";
	
	stateName[5]					= "ReloadB";
	stateTimeoutValue[5]			= 0.8;
	stateScript[5]					= "onReloadAnimCheck";
	stateTransitionOnTimeout[5]		= "ReloadAnimCheck";
	
	stateName[6]					= "ReloadC";
	stateSequence[6]				= "pop";
	stateScript[6]					= "onReload";
	stateDirection[6]				= 0;
	stateTimeoutValue[6]			= 0.3;
	stateTransitionOnTimeout[6]		= "Wait";
	
	stateName[7]					= "Wait";
	stateTimeoutValue[7]			= 0.4;
	stateTransitionOnTimeout[7]		= "Done";
	
	stateName[8]					= "ReloadAnimCheck";
	stateTransitionOnAmmo[8]		= "ReloadC";
	stateTransitionOnNoAmmo[8]		= "ReloadC_Special";
	
	stateName[9]					= "ReloadC_Special";
	stateSequence[9]				= "reloadTrick";
	stateScript[9]					= "onReloadTrick";
	stateTimeoutValue[9]			= 0.7;
	stateTransitionOnTimeout[9]		= "Done";
	
	stateName[10]					= "Done";
	stateScript[10]					= "onDone";
};
function revolverReloadImage::onLoad(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	serverPlay3D(revolverLoadSound,%pl.getPosition());
	sAmmo_reload(%db,%pl,%slot);
	%pl.setImageAmmo(%slot,1);
}
function revolverReloadImage::onEject(%db,%pl,%slot)
{
	sWeps_display(%pl,0);
	%pl.playThread(2,plant);
	%up = %pl.getUpVector();
	%forward = %pl.getEyeVectorHack();
	%a = new aiPlayer()
	{
		datablock = emptyPlayer;
		position = %pl.getPosition();
		scale = "1 1 1";
	};
	%a.setDamageLevel(100);
	%a.setTransform(%pl.getSlotTransform(0));
	%a.mountImage(revolverFakeEject,0);
	%a.mountImage(revolverFakeEject,1);
	%a.mountImage(revolverFakeEject,2);
	%a.schedule(80,delete);
	for(%i=0;%i<2;%i++)
		schedule(getRandom(200,300),0,serverPlay3D,small_bulletDrop @ getRandom(1,5) @ Sound,%pl.getPosition());
	for(%i=0;%i<3;%i++)
		schedule(getRandom(200,300),0,serverPlay3D,rifle_bulletDrop @ getRandom(1,2) @ Sound,%pl.getPosition());
}
function revolverReloadImage::onUnload(%db,%pl,%slot)
{
	%pl.playThread(2,shiftLeft);
	serverPlay3D(revolverOpenSound,%pl.getPosition());
}
function revolverReloadImage::onReload(%db,%pl,%slot)
{
	%pl.playThread(2,shiftRight);
	serverPlay3D(revolverCloseSound,%pl.getPosition());
	%pl.setImageLoaded(%slot,1);
}
function revolverReloadImage::onReloadTrick(%db,%pl,%slot)
{
	%pl.playThread(2,rotCW);
	%pl.schedule(490,playThread,2,plant);
	serverPlay3D(revolverCloseSound,%pl.getPosition());
	serverPlay3D(revolverTrickSound,%pl.getPosition());
	%pl.setImageLoaded(%slot,1);
}
function revolverReloadImage::onReloadAnimCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,getRandom(0,15));
}
function revolverReloadImage::onDone(%db,%pl,%slot)
{
	%pl.mountImage(revolverImage,0);
}
datablock ShapeBaseImageData(revolverTrickAImage : revolverImage)
{
	stateSequence[0]				= "trick";
	stateTimeoutValue[0]			= 0.36;
};
function revolverTrickAImage::onMount(%db,%pl,%slot)
{
	if(isObject(%cl = %pl.client))
		%cl.play3D(revolverTrickSound,%pl.getPosition());
	parent::onMount(%db,%pl,%slot);
	%pl.schedule(340,playThread,2,plant);
}
function revolverTrickAImage::onFireCheck(%db,%pl,%slot){revolverImage::onFireCheck(%db,%pl,%slot);}
function revolverTrickAImage::onDryFire(%db,%pl,%slot){revolverImage::onDryFire(%db,%pl,%slot);}
function revolverTrickAImage::onFire(%db,%pl,%slot){revolverImage::onFire(%db,%pl,%slot);}
function revolverTrickAImage::onTrig(%db,%pl,%slot){revolverImage::onTrig(%db,%pl,%slot);}
function revolverTrickAImage::onTrigPrep(%db,%pl,%slot){revolverImage::onTrigPrep(%db,%pl,%slot);}
function revolverTrickAImage::onReload(%db,%pl,%slot){revolverImage::onReload(%db,%pl,%slot);}

datablock ShapeBaseImageData(revolverTrickBImage : revolverImage)
{
	shapeFile = "./model/revolver_v3.dts";
	stateTimeoutValue[0]			= 0.42;
	stateSequence[0]				= "trick2";
};
function revolverTrickBImage::onMount(%db,%pl,%slot)
{
	if(isObject(%cl = %pl.client))
		%cl.play3D(revolverTrickSound,%pl.getPosition());
	parent::onMount(%db,%pl,%slot);
	%pl.schedule(400,playThread,2,plant);
}
function revolverTrickBImage::onFireCheck(%db,%pl,%slot){revolverImage::onFireCheck(%db,%pl,%slot);}
function revolverTrickBImage::onDryFire(%db,%pl,%slot){revolverImage::onDryFire(%db,%pl,%slot);}
function revolverTrickBImage::onFire(%db,%pl,%slot){revolverImage::onFire(%db,%pl,%slot);}
function revolverTrickBImage::onTrig(%db,%pl,%slot){revolverImage::onTrig(%db,%pl,%slot);}
function revolverTrickBImage::onTrigPrep(%db,%pl,%slot){revolverImage::onTrigPrep(%db,%pl,%slot);}
function revolverTrickBImage::onReload(%db,%pl,%slot){revolverImage::onReload(%db,%pl,%slot);}

datablock ShapeBaseImageData(revolverSpinImage)
{
	className = "WeaponImage";
	shapeFile = "./model/revolver_item_v3.dts";
	emap = true;
	mountPoint = 0;
	offset = 0 SPC 0 SPC -0.08;
	item = revolverItem;
	ammo = " ";
	projectile = revolverProjectile;
	projectileType = Projectile;
	
	casing = revolverShellDebris;
	shellExitDir        = "0.14 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = false;
	colorShiftColor = revolverItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.01;
	stateTransitionOnTimeout[0] 	= "SpinStart";
	
	stateName[1]					= "SpinStart";
	stateSequence[1]				= "startSpin";
	stateTimeoutValue[1]			= 0.15;
	stateScript[1]					= "onSpinStart";
	stateTransitionOnTimeout[1]		= "SpinAnimA";
	
	stateName[2]					= "SpinAnimA";
	stateSequence[2]				= "proSpin";
	stateTimeoutValue[2]			= 0.2;
	stateScript[2]					= "onSpinCheck";
	stateTransitionOnNoAmmo[3]		= "SpinStop";
	stateTransitionOnTimeout[2]		= "SpinAnimB";
	
	stateName[3]					= "SpinAnimB";
	stateSequence[3]				= "proSpin";
	stateTimeoutValue[3]			= 0.2;
	stateScript[3]					= "onSpinCheck";
	stateTransitionOnNoAmmo[3]		= "SpinStop";
	stateTransitionOnTimeout[3]		= "SpinAnimA";
	
	stateName[4]					= "SpinStop";
	stateSequence[4]				= "startSpin";
	stateScript[4]					= "onSpinStop";
	stateTimeoutValue[4]			= 0.1;
	stateDirection[4]				= 0;
	stateTransitionOnTimeout[4]		= "Done";
	
	stateName[5]					= "Done";
	stateScript[5]					= "onDone";
};
function revolverSpinImage::onSpinStart(%db,%pl,%slot)
{
	%pl.revSpinCnt = 0;
	%pl.playThread(2,plant);
	%pl.stopRevolverSpin = 0;
	%pl.revolverSpinSoundStartSched = revolverSpinImage.schedule(150,startSpinSound,%pl,%slot);
}
function revolverSpinImage::spinStop(%db,%pl,%slot,%drumrollSuper)
{
	%pl.stopRevolverSpin = 1;
}
function revolverSpinImage::startSpinSound(%db,%pl,%slot)
{
	sWeps_loopingAudioStart(%db,%pl,%slot,revolverSpinLoopSound);
}
function revolverSpinImage::onUnMount(%db,%pl,%slot)
{
	sWeps_loopingAudioEnd(%db,%pl,%slot,"");
	cancel(%pl.revolverSpinStop);
	cancel(%pl.revolverSpinSoundStartSched);
}
function revolverSpinImage::onSpinStop(%db,%pl,%slot)
{
	if(%pl.isPlayingLoopingAudio[%db,%slot+1])
	{
		%pl.isPlayingLoopingAudio[%db,%slot+1] = 0;
		%pl.stopAudio(%slot+1);
	}
	cancel(%pl.revolverSpinStop);
	%pl.playThread(2,plant);
}
function revolverSpinImage::onSpinCheck(%db,%pl,%slot)
{
	%pl.revLastSpin = getSimTime();
	if((%pl.revSpinCnt%20) >= 15 && (%pl.revSpinCnt%20) < 20)
		%pl.playThread(3,shiftTo);
	else if((%pl.revSpinCnt%20) >= 4 && (%pl.revSpinCnt%20) < 9)
		%pl.playThread(3,activate);
	else
		%pl.playThread(2,shiftLeft);
	
	%pl.revSpinCnt++;
	if(%pl.stopRevolverSpin)
	{
		%pl.stopRevolverSpin = 0;
		%pl.setImageAmmo(0,0);
		
		if(%pl.isPlayingLoopingAudio[%db,%slot+1])
		{
			%pl.isPlayingLoopingAudio[%db,%slot+1] = 0;
			%pl.schedule(150,stopAudio,%slot+1);
			%pl.schedule(150,playAudio,%slot,revolverSpinStopSound);
		}
	}
}
function revolverSpinImage::getAimVector(%db,%pl,%slot)
{
	%ltime = %pl.revLastSpin;
	%dtime = 200;
	%ctime = getSimTime()-%ltime;
	if(%ctime > %dtime)
		%ctime = %dtime;
	%p = 1-(%ctime/%dtime);
	
	%forward = %pl.getMuzzleVector(%slot);
	%upHack = %pl.getUpVectorHack();
	
	%right = vectorCross(%forward,%upHack);
	
	
	//%shift = vectorRelativeShift(%forward,%upHack,(mSin(($PI*2)*%p)*0.6) SPC 0 SPC (mCos((($PI)*%p)-($PI*0.4))*0.6));
	
	%spin = (($PI*2)*%p)-($PI*0.45);
	%vec = vectorAngleRotate(%forward,%right,%spin);
	//%vec = vectorAngleRotate(%vec,%upHack,0.33);
	
	return %vec;
}
function revolverSpinImage::onDone(%db,%pl,%slot)
{
	%pl.setImageAmmo(0,1);
	%pl.mountImage(revolverImage,0);
}
function revolverSpinImage::witnessMe(%db,%pl,%slot)
{
	if(!isObject(%pl))return;
	if((%pl.sAmmo[%x=nameToId(revolverItem)]-1)!=0){%pl.witnessMeSched = revolverSpinImage.schedule(100,witnessMe,%pl,0);return %pl.revolverPoints="";}
	if((!%e=%pl.getMountedImage(0))||!((nameToId(%e.item)-%x)+1))return %pl.revolverPoints="";
	cancel(%pl.witnessMeSched);
	%v = %pl.getForwardVector();
	for(%e=%pl.getEyePoint();%i<!%q+!%q+!%q;%i++)
	{
		if(!getWord(%r=containerRaycast(%e,vectorAdd(%e,vectorScale(%v=vectorAngleRotate(%v,%pl.getUpVector(),5e-1*(!%i?-1:1)),3*(!(%i-1)|%q?1.5:!%q))),!%q<<0x19|!%q),""))
			break;
		%i[%i|0] = getWords(%r,1,4);
	}
	if((%i==3) && !!((getWord(%i[0x0],%q)*(getWord(%i0,1)-getWord(%i2,1))+getWord(%i[%q],0)*(getWord(%i2,1)-getWord(%i[1e0],!%q))+getWord(%i[2],0)*(getWord(%i[!%q],1)-getWord(%i[0],!%q)))))
	{
		if(%v+((5.2-vectorDist(%e,%i[1]))*0.4) < 3)
		{
			%pl.revolverPoints += mAbs(%slot-(%d=(1-vectorDot(%pl.getEyeVectorHack(),%pl.getEyeVector()))));
			if(%pl.revolverPoints > 60)
			{
				if(%cl = %pl.client)
				{
					%pl.setDamageFlash(%cl.isBlessed = 1);
					while(%l++<4)
						%cl.play2d(revolverSummonSound);
					%db.schedule(1100,teachMe,%pl);
				}
				return;
			}
			else if(%pl.revolverPoints > 20)
				%pl.setDamageFlash((%pl.revolverPoints-20)/40*0.6);
		}
	}
	%pl.revolverPoints += (%pl.revolverPoints>0?-2e-1:%q);
	%pl.witnessMeSched=revolverSpinImage.schedule(100,witnessMe,%pl,%d);
}
function revolverSpinImage::teachMe(%db,%pl,%slot)
{
	if(!%slot)
	{
		messageClient(%pl.client,'',"\c3My eyes are on you.");
		%pl.mountImage(headBloodSprayImage,2);
		%p = new projectile()
		{
			datablock = heavyBulletBloodHitProjectile;
			scale = 1 SPC 1 SPC 1;
			initialPosition = %pl.getEyePoint();
		};
		%p.explode();
		%pl.hideNode("headskin");
		%c = 0;
		for(%i=0;$hat[%i]!$="";%i++)
		{
			if(%pl.isNodeVisible($hat[%i]))
			{
				%pl.tmpResetNode[%c] = $hat[%i];
				%c++;
				%pl.hideNode($hat[%i]);
			}
		}
		for(%i=0;$accent[%i]!$="";%i++)
		{
			if(%pl.isNodeVisible($accent[%i]))
			{
				%pl.tmpResetNode[%c] = $accent[%i];
				%c++;
				%pl.hideNode($accent[%i]);
			}
		}
		%db.schedule(1600,teachMe,%pl,1 SPC %c);
	}
	else
	{
		%p = new projectile()
		{
			datablock = bulletBloodHitProjectile;
			scale = 1 SPC 1 SPC 1;
			initialPosition = %pl.getEyePoint();
		};
		%p.explode();
		%c = getWord(%slot,1);
		for(%i=0;%i<%c;%i++)
		{
			%pl.unHideNode(%pl.tmpResetNode[%i]);
			%pl.tmpResetNode[%i] = "";
		}
		%pl.unMountImage(2);
		%pl.unHideNode("headskin");
	}
}
datablock ExplosionData(revolverShakeExplosion)
{
	explosionShape = "";
	lifeTimeMS = 50;

	faceViewer = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "1 1 2";
	camShakeAmp = "0.15 0.15 0.15";
	camShakeDuration = 1;
	camShakeRadius = 0.2;
};
datablock ProjectileData(revolverShakeProjectile)
{
	lifetime = 10;
	explodeOnDeath = true;
	explosion = revolverShakeExplosion;
};
datablock ShapeBaseImageData(revolverSuicideImage)
{
	className = "WeaponImage";
	shapeFile = "./model/revolver_item_v3.dts";
	emap = true;
	mountPoint = 0;
	offset = 0 SPC 0 SPC -0.08;
	eyeOffset = "0.6 0.9 -0.7";
	item = revolverItem;
	ammo = " ";
	projectile = revolverProjectile;
	projectileType = Projectile;
	
	casing = revolverShellDebris;
	shellExitDir        = "0.14 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	
	doColorShift = false;
	colorShiftColor = revolverItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.01;
	stateTransitionOnTimeout[0] 	= "To";
	
	stateName[1]					= "To";
	stateSequence[1]				= "to";
	stateTimeoutValue[1]			= 0.3;
	stateScript[1]					= "onTo";
	stateTransitionOnTimeout[1]		= "Idle";
	
	stateName[2]					= "Idle";
	stateTransitionOnNotLoaded[2]	= "Away";
	stateTransitionOnNoAmmo[2]		= "Suicide";
	
	stateName[3]					= "Away";
	stateSequence[3]				= "to";
	stateTimeoutValue[3]			= 0.3;
	stateDirection[3]				= 0;
	stateScript[3]					= "onAway";
	stateTransitionOnTimeout[3]		= "Done";
	
	stateName[4]					= "Done";
	stateScript[4]					= "onDone";

	stateName[5]					= "Suicide";
	stateEmitter[5]					= gunFlashEmitter;
	stateEmitterTime[5]				= 0.05;
	stateEmitterNode[5]				= "muzzlePoint";
	stateTransitionOnTimeout[5]		= "Done";
	stateFire[5]					= true;
	stateScript[5]					= "onFire";
};
function revolverSuicideImage::onTo(%db,%pl,%slot)
{
	serverPlay3D(revolverAimToSound,%pl.getPosition());
	%pl.playThread(2,shiftLeft);
	%pl.playThread(3,plant);
}
function revolverSuicideImage::onAway(%db,%pl,%slot)
{
	serverPlay3D(revolverAimAwaySound,%pl.getPosition());
	%pl.playThread(2,shiftRight);
	%pl.playThread(3,plant);
}
function revolverSuicideImage::onDone(%db,%pl,%slot)
{
	%pl.mountImage(revolverImage,0);
}
function revolverSuicideImage::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	%pl.hasShotOnce = 1;
	%pl.invincible = 0;
	%up = %pl.getUpVector();
	%muzVec = MatrixMulVector(%pl.getSlotTransform(0),"0 1 0");
	%forward = %pl.getForwardVector();
	%muzPoint = %pl.getMuzzlePoint(%slot);
	
	%rightVec = vectorCross(%forward,%up);
	%upHack = %pl.getUpVectorHack();
	
	%pl.schedule(2,damage,%pl,%pl.getPosition(),100,$DamageType::Revolver);
	%vel = vectorAngleRotate(vectorAngleRotate(%muzVec,%upHack,(3.141*(153/180))),%rightVec,-3.141*((12)/180));
	%p = new projectile()
	{
		dataBlock = revolverProjectile;
		initialVelocity = vectorScale(%vel,150);
		initialPosition = %muzPoint;
		sourceObject = %pl;
		sourceSlot = %slot;
		client = %pl.client;
	};
	%scale = 1;
	%p = new projectile()
	{
		datablock = heavyBulletBloodHitProjectile;
		scale = %scale SPC %scale SPC %scale;
		initialPosition = vectorAdd(%pl.getSlotTransform(2),vectorScale(%upHack,0.4));
	};
	%p.explode();
	MissionCleanup.add(%p);
	%pl.playThread(2,plant);
	serverPlay3D(revolverFire @ getRandom(1,2) @ Sound,%pl.getPosition());
	serverPlay3D(shotgunHitPl2Sound,%pl.getPosition());
	%pl.unMountImage(0);
	%pl.headExplosion();
}
function revolverSuicideImage::dramaStart(%db,%pl,%slot)
{
	if(!isObject(%cl = %pl.client))
		return;
	if(getRandom(0,3))
	{
		%pl.setImageAmmo(0,0);
		return;
	}
	%cl.play2D(revolverSUICIDESound);
	%pl.revFov = %cl.getControlCameraFov();
	%pl.revTimeCap = 2750;
	%pl.revTimeStop = getSimTime()+%pl.revTimeCap;
	%pl.revTimeStart = getSimTime();
	%db.drama(%pl,0);
	%pl.disableCmdSwap = 1;
}
function revolverSuicideImage::drama(%db,%pl,%slot)
{
	%cl = %pl.client;
	cancel(%pl.revSched);
	%time = getSimTime()-%pl.revTimeStart;
	%max = %pl.revTimeCap;
	if(getSimTime() > %pl.revTimeStop)
	{
		%cl.setControlCameraFov(%pl.revFov);
		%pl.setImageAmmo(0,0);
		commandToClient(%cl,'setVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor);
		return;
	}
	%prcnt = (1-(1+mCos($PI*(%time/%max)))/2);
	%cl.setControlCameraFov(%pl.revFov+((%prcnt)*(%pl.revFov/7)));
	if(%slot%(mFloor((1-%prcnt)*6)) == 0)
	{
		%scale = mClampF(%prcnt,0.5,1);
		%p = new Projectile()
		{
			datablock = revolverShakeProjectile;
			initialPosition = %pl.getPosition();
			initialVelocity = "0 0 0";
			client = %pl.client;
			sourceObject = %pl;
			scale = %scale SPC %scale SPC %scale;
		};
		%p.explode();
	}
	%alpha = mClampF((%prcnt+0.1)*0.8,0,1);
	%vigAlpha = mClampF(getWord($EnvGuiServer::VignetteColor,3),0,1);
	%fAlpha = mClampF(%alpha,mClampF(%vigAlpha,0,0.2),1);
	%pl.setDamageFlash(%prcnt*0.6);
	commandToClient(%cl,'setVignette',$EnvGuiServer::VignetteMultiply,rgbGradient(1-%alpha,"1 0 0",$EnvGuiServer::VignetteColor) SPC %fAlpha);
	%pl.revSched = %db.schedule(32,drama,%pl,%slot++);
}