function player::delayedCmdSwap(%pl,%remount)
{
	%pl.disableCmdSwap = 0;
	if(%pl.selTool $= "")
		return;
	if(%pl.selTool == -1)
	{
		serverCmdUnUseTool(%pl.client);
	}
	else if(%pl.selTool != %pl.currTool || %remount)
	{
		serverCmdUseTool(%pl.client,%pl.selTool);
	}
	%pl.selTool = "";
}
function item::setCanPickup(%item,%bool)
{
	%item.canPickup = %bool;
}
function swol_calculateDamagePosition(%pl,%hitPos)
{
	if(%pl.isCrouched())
	{
		%center = vectorAdd(%pl.getWorldBoxCenter(),"0 0 -1.49");
		%vecTo = vectorNormalize(vectorSub(getWords(%hitPos,0,1) SPC 0,getWords(%center,0,1) SPC 0));
		%forward = %pl.getForwardVector();
		%dot = vectorDot(%vecTo,%forward);
		if(%dot < 0.3)
			return "legs";
		if(%dot < 0.6)
			return "lowbody";
		else
			return "head";
	}
	else
	{
		%z = getWord(%hitPos,2);
		%zWorld = getWord(%pl.getWorldBoxCenter(),2);
		%diff = %zWorld-%z;
		%diff = 2.6-(%diff-2.65);
		
		if(%diff > 1.8)
			return "head";
		if(%diff > 1.35)
			return "upbody";
		if(%diff > 0.8)
			return "lowbody";
		else
			return "legs";
	}
}
function VectorRotateAxis(%vector,%axis,%angle)
{
	%x = getWord(%vector,0);
	%y = getWord(%vector,1);
	%z = getWord(%vector,2);
	%u = getWord(%axis,0);
	%v = getWord(%axis,1);
	%w = getWord(%axis,2);
	%ux = %u * %x;
	%uy = %u * %y;
	%uz = %u * %z;
	%vx = %v * %x;
	%vy = %v * %y;
	%vz = %v * %z;
	%wx = %w * %x;
	%wy = %w * %y;
	%wz = %w * %z;
	%sa = mSin(%angle);
	%ca = mCos(%angle);
	%nx = %u*(%ux+%vy+%wz)+(%x*(%v*%v+%w*%w)-%u*(%vy+%wz))*%ca+(-%wy+%vz)*%sa;
	%ny = %v*(%ux+%vy+%wz)+(%y*(%u*%u+%w*%w)-%v*(%ux+%wz))*%ca+(%wx-%uz)*%sa;
	%nz = %w*(%ux+%vy+%wz)+(%z*(%u*%u+%v*%v)-%w*(%ux+%vy))*%ca+(-%vx+%uy)*%sa;
	return(%nx SPC %ny SPC %nz);
}
function getAngleToPosition(%pos,%tpos)
{
	%z = getWord(%pos,2);
	%xs = getWord(%tpos,0);
	%ys = getWord(%tpos,1);
	%tpos = %xs SPC %ys SPC %z;
	%posX = getWord(%pos,0);
	%posY = getWord(%pos,1);
	
	%tposX = getWord(%tpos,0);
	%tposY = getWord(%tpos,1);
	
	%tx = %tposX - %posX;
	%ty = %tposY - %posY;
	%rad = mAtan(%ty,%tx);
	%angle = mFloor(%rad/$PI * 180)+180+90;
	%axis = eulerToAxis(0 SPC 0 SPC %angle);
}
function rotBetween(%a,%b)
{
	%v = vectorNormalize(vectorSub(%b,%a));
	%x = getWord(%v,0);
	%y = getWord(%v,1);
	%yaw = mATan(%x,%y) - $pi / 2;
	%pitch = 0 - mATan(getWord(%v,2),mSqrt(%x * %x + %y * %y));
	%xy = -90 - %pitch * 180 / $pi;
	%z = -90 - %yaw * 180 / $pi;
	return eulerToAxis(%xy SPC 0 SPC %z);
}
function rgbToHex(%rgb)
{
	%r = _compToHex(255*getWord(%rgb,0));
	%g = _compToHex(255*getWord(%rgb,1));
	%b = _compToHex(255*getWord(%rgb,2));

	return %r @ %g @ %b;
}
function _compToHex(%comp)
{
	%left = mFloor(%comp/16);
	%comp = mFloor(%comp-%left*16);

	%left = getSubStr("0123456789ABCDEF",%left,1);
	%comp = getSubStr("0123456789ABCDEF",%comp,1);

	return %left @ %comp;
}
function rgbGradient(%step,%c1,%c2)
{
	%r1 = getWord(%c1,0);
	%g1 = getWord(%c1,1);
	%b1 = getWord(%c1,2);

	%r2 = getWord(%c2,0);
	%g2 = getWord(%c2,1);
	%b2 = getWord(%c2,2);

	%r3 = %r1+%step*(%r2-%r1);
	%g3 = %g1+%step*(%g2-%g1);
	%b3 = %b1+%step*(%b2-%b1);

	return %r3 SPC %g3 SPC %b3;
}
function eulerToAxis(%euler)
{
	%euler = VectorScale( %euler, $pi / 180 );
	%matrix = MatrixCreateFromEuler( %euler );
	return getWords( %matrix, 3, 6 );
}
function axisToEuler(%axis)
{
	%angleOver2 = getWord( %axis, 3 ) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin( %angleOver2 );
	%cosThetaOver2 = mCos( %angleOver2 );
	%q0 = %cosThetaOver2;
	%q1 = getWord( %axis, 0 ) * %sinThetaOver2;
	%q2 = getWord( %axis, 1 ) * %sinThetaOver2;
	%q3 = getWord( %axis, 2 ) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * ( %q1q3 - %q0q2 );
	%m21 = 2.0 * ( %q1q2 - %q0q3 );
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * ( %q2q3 + %q0q1 );
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg( mAsin( %m23 ) ) SPC mRadToDeg( mAtan( -%m13, %m33 ) ) SPC mRadToDeg( mAtan( -%m21, %m22 ) );
}
function vectorAngleRotate(%vec,%ref,%ang) //thanks luna i love you and your big math brain
{
	%x = getWord(%vec,0);
	%y = getWord(%vec,1);
	%z = getWord(%vec,2);
	%u = getWord(%ref,0);
	%v = getWord(%ref,1);
	%w = getWord(%ref,2);
	%cos = mCos(%ang);
	%sin = mSin(%ang);
	return %u*(%u*%x+%v*%y+%w*%z)*(1-%cos)+%x*%cos+(%v*%z-%w*%y)*%sin SPC %u*(%u*%x+%v*%y+%w*%z)*(1-%cos)+%y*%cos+(%w*%x-%u*%z)*%sin SPC %u*(%u*%x+%v*%y+%w*%z)*(1-%cos)+%z*%cos+(%u*%y-%v*%x)*%sin;
}
function player::getUpVectorHack(%pl)
{
	return getUpFromVec(%pl.getEyeVector());
}
function getUpFromVec(%vec)
{
	%x = getWord(%vec,0);
	%y = getWord(%vec,1);
	%z = getWord(%vec,2);
	%up = vectorNormalize((-%x*%z) SPC (-%z*%y) SPC ((%x*%x)+(%y*%y)));
	return %up;
}
function player::getEyeVectorHack(%pl) //thanks port i love you and your cute eyes
{
    %forward = %pl.getForwardVector();
    %eye = %pl.getEyeVector();

    %x = getWord(%eye, 0);
    %y = getWord(%eye, 1);

    %yaw = mATan(getWord(%forward,0),getWord(%forward,1));
    %pitch = mATan(getWord(%eye,2),mSqrt(%x*%x+%y*%y));

    return MatrixMulVector(MatrixCreateFromEuler(%pitch SPC 0 SPC -%yaw),"0 1 0");
}
function vectorRelativeShift(%forward,%up,%shift)
{
	return vectorAdd(vectorAdd(vectorScale(%forward,getWord(%shift,0)),vectorScale(vectorCross(%forward,%up),getWord(%shift,1))),vectorScale(%up,getWord(%shift,2)));
}